<?php    


/* 
 * modified version, for use with weathermanager.php
 * search for string '###' to see where. 
 *
 * a button added.
 */ 

 


    require_once 'editor-config.php';
    require_once 'editor.inc.php';
    require_once 'Weathermap.class.php';
   
	
    $action = '';
    $mapname = '';
    $selected = '';
    
    $newaction = '';
    $param = '';
    $param2 = '';
    $log = '';
        
    module_checks();

    if(isset($_REQUEST['action'])) { $action = $_REQUEST['action']; }
    if(isset($_REQUEST['mapname'])) { $mapname = $_REQUEST['mapname']; }
    if(isset($_REQUEST['selected'])) { $selected = $_REQUEST['selected']; }

    if($mapname == '')
    {
        // this is the file-picker/welcome page
        show_editor_startpage();
    }
	else
	{  
    // everything else in this file is inside this else
    $mapfile = $mapdir.'/'.$mapname;        

    $map = new WeatherMap;

    switch($action)
    {
        case 'newmap':
            $map->WriteConfig($mapfile);
            break;
        
        case 'font_samples':
            header('Content-type: image/png');

            $im = imagecreate(250,imagefontheight(5)+5);
            
            $white = imagecolorallocate($im,255,255,255);
            $black = imagecolorallocate($im,0,0,0);

            $x = 3;
            for($i=1; $i< 6; $i++)
            {
                imagestring($im, $i, $x, 2, "Font $i", $black);
                $x = $x + imagefontwidth($i)*7;
            }
            imagepng($im);
            imagedestroy($im);

            exit();        
            break;
        case 'draw':
            header('Content-type: image/png');
            $map->ReadConfig($mapfile);

            if($selected != '')
            {
                if(substr($selected,0,5) == 'NODE:')
                {
                    $nodename = substr($selected,5);
                    $map->nodes[$nodename]->selected=1;
                }
                
                if(substr($selected,0,5) == 'LINK:')
                {
                    $linkname = substr($selected,5);
                    $map->links[$linkname]->selected=1;
                }
            }

            $map->sizedebug = TRUE;
//            $map->RandomData();
            $map->DrawMap();
            exit();
            break;

	case 'show_config':
            	header('Content-type: text/plain');

		$fd = fopen($mapfile,'r');
		while (!feof($fd))
   		{
       			$buffer = fgets($fd, 4096);
       			echo $buffer;
   		}
		fclose($fd);

		exit();
		break;
        
        case "set_node_properties":
			$map->ReadConfig($mapfile);

			$node_name = $_REQUEST['node_name'];
			$new_node_name = $_REQUEST['node_name'];

            if($node_name != $new_node_name)
            {
                // we need to rename the node first.
            }

		$map->nodes[$node_name]->label = $_REQUEST['node_label'];
		$map->nodes[$node_name]->infourl = $_REQUEST['node_infourl'];
		$map->nodes[$node_name]->overliburl = $_REQUEST['node_hover'];
		
		if($_REQUEST['node_iconfilename'] == '--NONE--')
		{
		    $map->nodes[$node_name]->iconfile='';    
		}
		else
		{
		    $map->nodes[$node_name]->iconfile = stripslashes($_REQUEST['node_iconfilename']);
		}
			
		$map->WriteConfig($mapfile);
                break;

        case "set_link_properties":
			$map->ReadConfig($mapfile);
			$link_name = $_REQUEST['link_name'];

			$map->links[$link_name]->width = intval($_REQUEST['link_width']);
			$map->links[$link_name]->infourl = $_REQUEST['link_infourl'];
			$map->links[$link_name]->overliburl = $_REQUEST['link_hover'];
			
			// $map->links[$link_name]->target = $_REQUEST['link_target'];

			$targets = preg_split('/\s+/',$_REQUEST['link_target'],-1,PREG_SPLIT_NO_EMPTY); 
			$new_target_list = array();
            			
            foreach ($targets as $target)
            {
               // we store the original TARGET string, and line number, along with the breakdown, to make nicer error messages later
               $newtarget = array($target,'traffic_in','traffic_out',0,$target);
            
              # if it's an RRD file, then allow for the user to specify the
              # DSs to be used. The default is traffic_in, traffic_out, which is
              # OK for Cacti (most of the time), but if you have other RRDs...
              if(preg_match("/(.*\.rrd):([\-a-zA-Z0-9_]+):([\-a-zA-Z0-9_]+)$/i",$target,$matches))
              {
                $newtarget[0] = $matches[1];
                $newtarget[1] = $matches[2];
                $newtarget[2] = $matches[3];
              }
			  // now we've (maybe) messed with it, we'll store the array of target specs
              $new_target_list[] = $newtarget;
			}
			$map->links[$link_name]->targets = $new_target_list;
         	
            $bwin = $_REQUEST['link_bandwidth_in'];
	   	    $bwout = $_REQUEST['link_bandwidth_out'];
			
			if(isset($_REQUEST['link_bandwidth_out_cb']))
			{
    			$bwout = $bwin;
			}
			
			$map->links[$link_name]->SetBandwidth($bwin,$bwout);

            $map->WriteConfig($mapfile);
            break;
            
        case "set_map_properties":
            $map->ReadConfig($mapfile);
                        
            $map->title = $_REQUEST['map_title'];
            $map->keytext = $_REQUEST['map_legend'];
            $map->stamptext = $_REQUEST['map_stamp'];

            $map->htmloutputfile = $_REQUEST['map_htmlfile'];
            $map->imageoutputfile = $_REQUEST['map_pngfile'];

            $map->width = intval($_REQUEST['map_width']);
            $map->height = intval($_REQUEST['map_height']);
	    
	    // XXX sanitise this a bit
	    if($_REQUEST['map_bgfile'] == '--NONE--')
	    {
		$map->background='';    
	    }
	    else
	    {
		$map->background = stripslashes($_REQUEST['map_bgfile']);
	    }
            
            $map->defaultlink->width = intval($_REQUEST['map_linkdefaultwidth']);
            
            $bwin = $_REQUEST['map_linkdefaultbwin'];
	    $bwout = $_REQUEST['map_linkdefaultbwout'];
                        
	    $map->defaultlink->SetBandwidth($bwin,$bwout);
                        
            $map->WriteConfig($mapfile);
            break; 

        case 'set_map_style':
            $map->ReadConfig($mapfile);

            $map->defaultlink->labelstyle = $_REQUEST['mapstyle_linklabels'];
            $map->htmlstyle = $_REQUEST['mapstyle_htmlstyle'];
            $map->defaultlink->arrowstyle = $_REQUEST['mapstyle_arrowstyle'];

            $map->defaultlink->bwfont = intval($_REQUEST['mapstyle_linkfont']);
            $map->defaultnode->labelfont = intval($_REQUEST['mapstyle_nodefont']);
            $map->keyfont = intval($_REQUEST['mapstyle_legendfont']);

            $map->WriteConfig($mapfile);
            break;
        
        case "add_link":
            $map->ReadConfig($mapfile);

			$param2 = $_REQUEST['param'];
            $newaction = 'add_link2';
            $selected = 'NODE:'.$param2;         
            break;
            
        case "add_link2":
            $map->ReadConfig($mapfile);
            $a = $_REQUEST['param2'];
            $b = $_REQUEST['param'];
            $log = "[$a -> $b]";
            
            if($a != $b)
            {
                $newlink = new WeatherMapLink;
                $newlink->Reset($map);
                $newlink->a = $map->nodes[$a];
                $newlink->b = $map->nodes[$b];
                $newlink->SetBandwidth($map->defaultlink->max_bandwidth_in_cfg, $map->defaultlink->max_bandwidth_out_cfg);
                $newlink->width = $map->defaultlink->width;
		
		# make sure the link name is unique. We can have multiple links between
		# the same nodes, these days
		$newlinkname = "$a-$b";
		while(array_key_exists($newlinkname,$map->links))
		{
		    $newlinkname .= "a";
		}
                $newlink->name = $newlinkname;
                $map->links[$newlinkname] = $newlink;
                
                $map->WriteConfig($mapfile);
            }          
            break;

	case "place_legend":
			$x = intval($_REQUEST['x']);
            $y = intval($_REQUEST['y']);
            
			$map->ReadConfig($mapfile);

			$map->keyx = $x;
            $map->keyy = $y;

            $map->WriteConfig($mapfile);
			break;
            
	case "place_stamp":
			$x = intval($_REQUEST['x']);
            $y = intval($_REQUEST['y']);

			$map->ReadConfig($mapfile);

			$map->timex = $x;
            $map->timey = $y;

            $map->WriteConfig($mapfile);
			break;

        case "move_node":
            $x = intval($_REQUEST['x']);
            $y = intval($_REQUEST['y']);
        	$node_name = $_REQUEST['node_name'];
		
            $map->ReadConfig($mapfile);

        	$map->nodes[$node_name]->x = $x;
        	$map->nodes[$node_name]->y = $y;

            $map->WriteConfig($mapfile);
            break;

        case "add_node":
            $x = intval($_REQUEST['x']);
            $y = intval($_REQUEST['y']);

            $map->ReadConfig($mapfile);

            $node = new WeatherMapNode;
            $node->Reset($map);

            $node->x = snap($x);
            $node->y = snap($y);
            $node->name = "node".time();
            $node->label = "NODE";

            $map->nodes[$node->name] = $node;

            $map->WriteConfig($mapfile);
            break;
            
        case "delete_link":
            $map->ReadConfig($mapfile);

            $target = $_REQUEST['param'];
            $log = "delete link ".$target;
        
            unset($map->links[$target]);
        
            $map->WriteConfig($mapfile);
            break;
            
        case "delete_node":
            $map->ReadConfig($mapfile);

            $target = $_REQUEST['param'];
            $log = "delete node ".$target;
        
            foreach ($map->links as $link)
                {
                    if( ($target == $link->a->name) || ($target == $link->b->name) )
                    {
                        unset($map->links[$link->name]);
                    }
                }           
        
            unset($map->nodes[$target]);
        
            $map->WriteConfig($mapfile);
            break;
            
        // no action was defined - starting a new map?
        default:
            $map->ReadConfig($mapfile);
            break;   
    }


    // now we'll just draw the full editor page, with our
    // new knowledge
    
    $imageurl = '?mapname='.$mapname . '&amp;action=draw';
    if($selected != '')
    {
        $imageurl .= '&amp;selected='.$selected;
    }

    $imageurl .= '&amp;unique='.time();
    
    $imlist = get_imagelist("images")
    
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<style>
    <?
        // if the cacti config was included properly, then 
        // this will be non-empty, and we can unhide the cacti links in the Link Properties box
        if( ! isset($config['cacti_version']) )
        {
            echo "    .cactilink { display: none; }\n";
        }
   ?>
    </style>
  <link rel="stylesheet" type="text/css" media="screen" href="editor.css" />
  <script src="editor.js" type="text/javascript"></script>
  <script type="text/javascript">
  // the only javascript in here should be the objects representing the map itself
  // all code should be in editor.js
  <? print $map->asJS() ?>
  <?
    
    // append any images used in the map that aren't in the images folder
    foreach ($map->used_images as $im)
    {
	if(! in_array($im,$imlist))
	{
	    $imlist[]=$im;
	}
    }
       
    sort($imlist);
    
    if(1==0)
    {
	$out = "";
	$out .= 'var mapimages = [';
	
	foreach ($imlist as $im)
	{
	    $out .= js_escape($im);
	    $out .= ",";
	}
	$out = rtrim($out,', ');
	$out .= "];\n";
	print $out;
    }
  ?>
  </script>
  <title>PHP Weathermap Editor <? echo $WEATHERMAP_VERSION; ?></title>
</head>

<body id="mainview">
  <div id="toolbar">
    <ul>
      <li class="tb_active" id="tb_newfile">Change<br />File</li>
      <li class="tb_active" id="tb_addnode">Add<br />Node</li>
      <li class="tb_active" id="tb_addlink">Add<br />Link</li>
      <li class="tb_active" id="tb_poslegend">Position<br />Legend</li>
      <li class="tb_active" id="tb_postime">Position<br />Timestamp</li>
      <li class="tb_active" id="tb_mapprops">Map<br />Properties</li>
      <li class="tb_active" id="tb_mapstyle">Map<br />Style</li>
      <li class="tb_active" id="tb_colours">Manage<br />Colors</li>
      <li class="tb_active" id="tb_manageimages">Manage<br />Images</li>
      <li class="tb_active" id="tb_prefs">Editor<br />Settings</li>
 
      <!-- ### the modification --> 								  
      <li class="tb_active" id="tb_manager">Weathermap<br />Manager</li>
      

      <li class="tb_help"><span id="tb_help">or click a Node or Link to edit it's properties</span></li>
    </ul>
  </div>

  <form action="editor.php" method="post" name="frmMain">
    <div align="center">
     <input style="display:none" type="image"
      src="<?= $imageurl; ?>" id="xycapture" /><img src=
      "<?= $imageurl; ?>" id="existingdata" alt="Weathermap" usemap="#weathermap_imap"
       /><br /><div class="debug">Debugging: <input type="text" name="mapname" value="<?= $mapname; ?>" /><input 
      type="text" id="action" name="action" value="<?= $newaction ?>" /><input type="text" name=
      "param" id="param" value="" /><input type="text" name=
      "param2" id="param2" value="<?= $param2 ?>" /><input id="debug" value="" name="debug" /><br /><a target="configwindow" href="?action=show_config&amp;mapname=<?= $mapname ?>">See config</a>  <a href="?action=nothing&amp;mapname=<?= $mapname ?>">Do Nothing (Reload Cleanly)</a>
    <?= $log ?>
      </div>
       <map name="weathermap_imap">
     <?        	
            // we need to draw and throw away a map, to get the
            // dimensions for the imagemap. Oh well.
            $map->DrawMap('null');
            $map->htmlstyle='editor';
            $map->PreloadMapHTML();
         
            print $map->imap->subHTML("LEGEND");
            print $map->imap->subHTML("TIMESTAMP");
            print $map->imap->subHTML("NODE:");
            print $map->imap->subHTML("LINK:");
     ?>
           </map>
    </div><!-- Node Properties -->

    <div id="dlgNodeProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Node Properties
		<input size="6" name="node_name" type="hidden" />
        <ul>
          <li><a id="tb_node_submit" title="Submit any changes made">Submit</a></li>
          <li><a id="tb_node_cancel" title="Cancel any changes">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
          <tr>
            <th>Internal Name</th>
            <td><input id="node_new_name" name="node_new_name" type="text" /></td>
          </tr>
          <tr>
            <th>Label</th>
            <td><input id="node_label" name="node_label" type="text" /></td>
          </tr>
          <tr>
            <th>Info URL</th>
            <td><input id="node_infourl" name="node_infourl" type="text" /></td>
          </tr>
          <tr>
            <th>'Hover' Graph URL</th>
            <td><input id="node_hover" name="node_hover" type="text" />[Pick from
            Cacti] (not yet)</td>
          </tr>
          <tr>
            <th>Icon Filename</th>
            <td><select id="node_iconfilename" name="node_iconfilename">
        	
	    <?php
		if(count($imlist)==0)
		{
		    print '<option value="--NONE--">(no images are available)</option>';
		}
		else
		{
		    print '<option value="--NONE--">--NO ICON--</option>';
		    foreach ($imlist as $im)
		    {
			print "<option ";
			print "value=\"$im\">$im</option>\n";
		    }
		}
	    ?>
		
		
		</select></td>
          </tr>
          <tr>
            <th></th>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <th></th>
            <td><a id="node_move" class="dlgTitlebar">Move Node</a><a class="dlgTitlebar" id="node_delete">Delete Node</a></td>
          </tr>
        </table>
      </div>

      <div class="dlgHelp" id="node_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Node Properties -->
    
    
    
    
    <!-- Link Properties -->

    <div id="dlgLinkProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Link Properties

        <ul>
          <li><a title="Submit any changes made" id="tb_link_submit">Submit</a></li>
          <li><a title="Cancel any changes" id="tb_link_cancel">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <div class="comment">
          Link from '<span id="link_nodename1">%NODE1%</span>' to '<span id="link_nodename2">%NODE2%</span>'
        </div>

		<input size="6" name="link_name" type="hidden" />

          <table>
            <tr>
              <th>Maximum Bandwidth<br />
              Into '<span id="link_nodename1a">%NODE1%</span>'</th>
              <td><input size="8" id="link_bandwidth_in" name="link_bandwidth_in" type=
              "text" /> bits/sec</td>
            </tr>
            <tr>
              <th>Maximum Bandwidth<br />
              Out of '<span id="link_nodename1b">%NODE1%</span>'</th>
              <td><input type="checkbox" id="link_bandwidth_out_cb" name=
              "link_bandwidth_out_cb" value="symmetric" />Same As
              'In' or <input id="link_bandwidth_out" name="link_bandwidth_out"
              size="8" type="text" /> bits/sec</td>
            </tr>
            <tr>
              <th>Data Source</th>
              <td><input id="link_target" name="link_target" type="text" /> <span class="cactilink"><a id="link_cactipick">[Pick
              from Cacti]</a></span></td>
            </tr>
            <tr>
              <th>Link Width</th>
              <td><input id="link_width" name="link_width" size="3" type="text" />
              pixels</td>
            </tr>
            <tr>
              <th>Info URL</th>
              <td><input id="link_infourl" size="20" name="link_infourl" type="text" /></td>
            </tr>
            <tr>
              <th>'Hover' Graph URL</th>
              <td><input id="link_hover"  size="20" name="link_hover" type="text" /></td>
            </tr>
            <tr>
              <th></th>
              <td>&nbsp;</td>
            </tr>
            <tr>
              <th></th>
              <td><a class="dlgTitlebar" id="link_delete">Delete
              Link</a></td>
            </tr>
          </table>
      </div>

      <div class="dlgHelp" id="link_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Link Properties -->

    <!-- Map Properties -->

    <div id="dlgMapProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Map Properties

        <ul>
          <li><a title="Submit any changes made" id="tb_map_submit">Submit</a></li>
          <li><a title="Cancel any changes" id="tb_map_cancel">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
          <tr>
            <th>Map Title</th>
            <td><input name="map_title" size="25" type="text" value="<?= $map->title ?>"/></td>
          </tr>
        <tr>
            <th>Legend Text</th>
            <td><input name="map_legend" size="25" type="text" value="<?= $map->keytext ?>" /></td>
          </tr>
        <tr>
            <th>Timestamp Text</th>
            <td><input name="map_stamp" size="25" type="text" value="<?= $map->stamptext ?>" /></td>
          </tr>
        
        <tr>
            <th>Default Link Width</th>
            <td><input name="map_linkdefaultwidth" size="6" type="text" value="<?= $map->defaultlink->width ?>" /> pixels</td>
          </tr>
        
        <tr>
            <th>Default Link Bandwidth</th>
            <td><input name="map_linkdefaultbwin" size="6" type="text" value="<?= $map->defaultlink->max_bandwidth_in_cfg ?>" /> bit/sec in, <input name="map_linkdefaultbwout" size="6" type="text" value="<?= $map->defaultlink->max_bandwidth_out_cfg ?>" /> bit/sec out</td>
          </tr>
          
        
          <tr>
            <th>Map Size</th>
            <td><input name="map_width" size="5" type=
            "text"  value="<?= $map->width ?>" /> x <input name="map_height" size="5" type=
            "text"  value="<?= $map->height ?>" /> pixels</td>
          </tr>
           <tr>
            <th>Output PNG Filename</th>
            <td><input name="map_pngfile" type="text"  value="<?= $map->imageoutputfile ?>" /></td>
          </tr>
          <tr>
            <th>Output HTML Filename</th>
            <td><input name="map_htmlfile" type="text" value="<?= $map->htmloutputfile ?>" /></td>
          </tr>
          <tr>
            <th>Background Image Filename</th>
            <td><select name="map_bgfile">
	    
	      <?php
		if(count($imlist)==0)
		{
		    print '<option value="--NONE--">(no images are available)</option>';
		}
		else
		{
		    print '<option value="--NONE--">--NONE--</option>';
		    foreach ($imlist as $im)
		    {
			print "<option ";
			if($map->background == $im) print " selected ";
			print "value=\"$im\">$im</option>\n";
			
		    }
		}
	    ?>
            </select></td>
          </tr>
        </table>
      </div>

      <div class="dlgHelp" id="map_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Map Properties -->

    <!-- Map Style -->
    <div id="dlgMapStyle" class="dlgProperties">
      <div class="dlgTitlebar">
        Map Style

        <ul>
          <li><a title="Submit any changes made" id="tb_mapstyle_submit">Submit</a></li>
          <li><a title="Cancel any changes" id="tb_mapstyle_cancel">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
          <tr>
            <th>Link Labels</th>
            <td><select name="mapstyle_linklabels">
              <option <? echo ($map->defaultlink->labelstyle=='bits' ? 'selected' : '') ?> value="bits">Bits/sec</option>
              <option <? echo ($map->defaultlink->labelstyle=='percent' ? 'selected' : '') ?> value="percent">Percentage</option>
              <option <? echo ($map->defaultlink->labelstyle=='none' ? 'selected' : '') ?> value="none">None</option>
            </select></td>
          </tr>
          <tr>
            <th>HTML Style</th>
            <td><select name="mapstyle_htmlstyle">
              <option <? echo ($map->htmlstyle=='overlib' ? 'selected' : '') ?> value="overlib">Overlib (DHTML)</option>
              <option <? echo ($map->htmlstyle=='static' ? 'selected' : '') ?> value="static">Static HTML</option>
            </select></td>
          </tr>
          <tr>
            <th>Arrow Style</th>
            <td><select name="mapstyle_arrowstyle">
              <option <? echo ($map->defaultlink->arrowstyle=='classic' ? 'selected' : '') ?> value="classic">Classic</option>
              <option <? echo ($map->defaultlink->arrowstyle=='compact' ? 'selected' : '') ?> value="compact">Compact</option>
            </select></td>
          </tr>
          <tr>
            <th>Node Font</th>
            <td><select name="mapstyle_nodefont"><?
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->defaultnode->labelfont == $i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->defaultnode->labelfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr>
            <th>Link Label Font</th>
            <td><select name="mapstyle_linkfont"><?
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->defaultlink->bwfont==$i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->defaultlink->bwfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr>
            <th>Legend Font</th>
            <td><select name="mapstyle_legendfont"><?
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->keyfont==$i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->keyfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr>
            <th>Font Samples:</th>
            <td><img src="?action=font_samples&mapname=<?= $mapname?>" /><br />(Drawn using your PHP install)</td>
          </tr>
        </table>
      </div>

      <div class="dlgHelp" id="mapstyle_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Map Style -->



    <!-- Colours -->

    <div id="dlgColours" class="dlgProperties">
      <div class="dlgTitlebar">
        Manage Colors

        <ul>
          <li><a title="Submit any changes made" id="tb_colours_submit">Submit</a></li>
          <li><a title="Cancel any changes" id="tb_colours_cancel">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        Nothing in here works yet. The aim is to have a nice color picker somehow.
        <table>
          <tr>
            <th>Background Color</th>
            <td></td>
          </tr>

          <tr>
            <th>Link Outline Color</th>
            <td></td>
          </tr>
        <tr>
        <th>Scale Colors</th>
        <td>Some pleasant way to design the bandwidth color scale goes in here???</td>
        </tr>

        </table>
      </div>

      <div class="dlgHelp" id="colours_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Colours -->


    <!-- Images -->

    <div id="dlgImages" class="dlgProperties">
      <div class="dlgTitlebar">
        Manage Images

        <ul>
          <li><a title="Submit any changes made" id="tb_images_submit">Submit</a></li>
          <li><a title="Cancel any changes" id="tb_images_cancel">Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <p>Nothing in here works yet. </p>
        The aim is to have some nice way to upload images which can be used as icons or backgrounds.
        These images are what would appear in the dropdown boxes that don't currently do anything in the Node and Map Properties dialogs. This may end up being a seperate page rather than a dialog box...       
      </div>

      <div class="dlgHelp" id="images_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Images -->

  </form>
</body>
</html>
<?
	} // if mapname != ''
?>
