<?Php

/*
 * Weathermanage 1.0
 * Mathieu Gilardet (matam@chokolate.org) 
 * Released under the GNU Public License
 *
 * application for genenerating easily config files for weathermap, 
 * using cacti database, and snmp queries. 
 *
 * page which display content. 
 * all environement data such as mysql access is stored inside a session array
 **/ 

session_start(); 
$_SESSION['debug'] = 0; 


/* include the function file */ 
include("weathermanage_lib.php"); 

/* if db SESSION fields empty, init system. */ 
if (!$_SESSION['my_host'] && !$_SESSION['my_login'] && !$_SESSION['my_pass'] && !$SESSION['my_db']) init();


/* get posted action */ 
$option=$_POST['option'];
if ($option == "") {

  /* if no option is specified, default is 'lastview value' */
  if (strcmp($_SESSION['lastview'], "node") == 0) {
    $option="Device View";
  } 
  else if (strcmp($_SESSION['lastview'], "road") == 0) {
    $option="Road View";
  } 

  /* ...or 'show devices' */
  else {
    $option="Device View"; 
  }
}

/* update session variables, if necessary */
if ($_POST['configitem'] != "") { 
  $_SESSION['configitem'] = $_POST['configitem']; 
}
     
/* if it stills no config specification (at startup), configitem keeps "" 
   => two cases: default should be 'conf1' or 'noconf'
      checked below while getting all available configs.
   caution: should only happen at startup or page reload. 
*/

/* open database */
$link = mysql_connect($_SESSION['my_host'],$_SESSION['my_login'],$_SESSION['my_pass']);
if (!$link) {
  die('Unable to connect database... ' . mysql_error());
} 
$db = mysql_select_db($_SESSION['my_db'], $link);
if (!$db) {
  die ('Unable to use specified datbase... ' . mysql_error());
}

/* include css (if not generating) */ 
if ($option != "Generate") print "<link rel=\"stylesheet\" type=\"text/css\" href=\"weathermanage.css\">";

/* if more than 5 reload, do a cacti sync (if not generate action */
if ($option != "Generate") {
  if (!$_SESSION['reload'] || $_SESSION['reload'] > 5) {
    sync(); 
  }
  else {
    $_SESSION['reload']++;
  }
}

/* 
 * start displaying page, 
 * according to the $option value 
 */


/* select config action */
if ($option == "Select") {
  
  /* backup previous selection and set view */ 
  if ($_SESSION['lastview'] == "node") {
    save_nodes_to_config($_SESSION['prevconfig']);
    $option="Device View"; 
  }
  else if ($_SESSION['lastview'] == "graph") {
    save_graphs_to_config($_SESSION['prevconfig']);
  } 
  else {
    $option="Road View";
  }
}


/* delete config action */ 
else if ($option == "Delete") {

  /* first save conf */ 
  if ($_SESSION['lastview'] == "node") save_nodes_to_config($_SESSION['prevconfig']);

  else if ($_SESSION['lastview'] == "graph") save_graphs_to_config($_SESSION['prevconfig']);

  /* display form */ 
  display_delete_confirmation(); 
}




/* if delete has been confirmed */ 
else if ($option == "Yes") {

  /* after reload, session element will be empty, as a startup 
     (so will be set to the first) */
  delete_conf($_SESSION['configitem']); 
  
  /* reset option */
  if (strcmp($_SESSION['lastview'], "road") == 0) {
    $option = "Road View"; 
  }
  else {
    $option = "Device View"; 
  }
} 




/* ..or not: same as 'cancel' */ 
else if ($option == "No") {

  if (strcmp($_SESSION['lastview'], "road") == 0)  
    $option="Road View";
  else 
    $option="Device View"; 
}



/* delete road action */ 
else if (strcmp($option, "Delete Selected") == 0) {

  /* proceed */ 
  delete_roads(); 

  /* reset option */
  if (strcmp($_SESSION['lastview'], "road") == 0) {
    $option = "Road View"; 
  }
  else {
    $option = "Device View"; 
  }
} 






/* store created form into memory */ 
else if ($option == "Store") {
 
 
  /* they are several types of form */ 
  
  /* the new config form */ 
  if (strcmp($_SESSION['lastform'], 'conf') == 0) {
    $done = store_conf("create"); 
    
    /* form checked successfull */  
    if ($done) {
      $_SESSION['lastform'] = ""; 
    }

    /* something wrong, back to form edit page */ 
    else {

      mysql_close(); 
      print '<br><a href="weathermanage.php">Back</a><br>'; 
      exit; 
    }
  }

  /* the new road form */ 
  else if (strcmp($_SESSION['lastform'], 'road') == 0) {
    store_road(); 
    $_SESSION['lastform'] = ""; 
  }


  /* select the view type and display */ 
  if (strcmp($_SESSION["lastview"], "road") == 0) {
    $option = "Road View"; 
  }
  else {
    $option = "Device View"; 
  }
  
}


/* add new road action */ 
else if (strcmp($option, "Add New Road") == 0) {

  /* save form type */ 
  $_SESSION['lastform'] = "road";

  /* display */ 
  add_new_road(); 

  /* end of display reached */
  mysql_close(); 
  exit;
}


/* event get from the create road page or from the create config. 
   option get the last page visited (road or device) */ 
else if (strcmp($option, "Cancel") == 0) {
  
  unset_conf_form(); 
  unset($_SESSION['md']);

  if ($_SESSION['lastview'] == "road") $option="Road View";
  else $option="Device View"; 
  
}



/* the 'update' buttton, found on edit conf form */
else if ($option == "Update") {

  $done = store_conf("update"); 
  
  /* form checked successfull */  
  if ($done) {
    $_SESSION['lastform'] = ""; 
  }
  
    /* something wrong, back to form edit page */ 
  else {
    
    mysql_close(); 
    print '<br><a href="weathermanage.php">Back</a><br>'; 
    exit; 
  }

  /* was updated successfull, redisplay */ 
  if (strcmp($_SESSION['lastview'], "node") == 0) 
    $option="Device View"; 
  else 
    $option="Road View";
}



/* create config action */   
else if ($option == "Create New" || $_SESSION['md'] == "create") {

  /* then backup previous node selection if node view */ 
  if (strcmp($_SESSION['lastview'], "node") == 0)
    save_nodes_to_config($_SESSION['prevconfig']);

  else if ($_SESSION['lastview'] == "graph") save_graphs_to_config($_SESSION['prevconfig']);

  /* save form type */ 
  $_SESSION['lastform'] = "conf";

  /* call create form */
  $_SESSION['md'] = "create";
  show_conf_form();
  mysql_close(); 
  exit; 
}


/* edit config action */ 
else if ($option == "Edit" || $_SESSION['md'] == "update") {

  /* if no configs */ 
  if (strcmp($_SESSION['configitem'], 'noconf') == 0) {
    if (strcmp($_SESSION['lastview'], "node") == 0) {
      $option="Device View"; 
    }
    else {
      $option="Road View";
    }
  }
  else {

    /* backup if was device view */ 
    if ($_SESSION['lastview'] == "node") save_nodes_to_config($_SESSION['prevconfig']);
    else if ($_SESSION['lastview'] == "graph") save_graphs_to_config($_SESSION['prevconfig']);

    edit_config($_SESSION['configitem']); 
    mysql_close(); 
    exit(); 
  }
}

/* generate config action */ 
else if (strcmp($option, "Generate") == 0) {
  
   /* first backup previous node selection if node view */ 
    if ($_SESSION['lastview'] == "node") save_nodes_to_config($_SESSION['prevconfig']);
    else if ($_SESSION['lastview'] == "graph") save_graphs_to_config($_SESSION['prevconfig']);
  
  /* call generation function */ 
  generate(); 

  /* statement never reached, but used as debug feature */ 
  if ($_SESSION['debug']) print "<div class=debug>Spank me...</div>";
  exit;
}





/*
 *   .o(  e l s e:  )o.
 *  road, node or monitor view is shown 
 */ 


/* build an array containg all conf names to $confs */
$confs = array();
$query="select name from weathermap_conf order by id asc";
$result = mysql_query($query);
while ($record = mysql_fetch_array($result)) {
  $conf=$record['name'];
  array_push($confs, $conf); 
}


/* display current used config and update session var for preventing failures */
if (count($confs) == 0) {
  $config="[NONE]";

  /* when starting or reloading, this var may not be set. do it now. */ 
  $_SESSION['configitem'] = "noconf";

}
else {

  $cfg = $_SESSION['configitem'];

  /* ensure configitem has always a valid value. */ 
  if ($_SESSION['configitem'] == "" || strcmp($_SESSION['configitem'], "noconf") == 0) 
    $_SESSION['configitem'] = "conf1";

  $index = substr($_SESSION['configitem'], 4, 2); 
  $config=$confs[($index-1)]; 

}

/* at this point we are sure having found conf file, so get the configuration mode */
$query = "select id, mode from weathermap_conf group by id asc";
$result = mysql_query($query); 
if ($result == NULL) houston($query); 
$index = substr($_SESSION['configitem'], 4, 1);    
for ($i=0; $i<$index ; $i++) {
  $record = mysql_fetch_array($result); 
  $id = $record['id']; 
  $mode = $record['mode']; 
}
if ($mode == 2) $option = "monitor"; 
else if ($option == "Select") $option = "Device View"; 


$cfgitem = $_SESSION['configitem'];
print "<div class=\"confheader\">Current used config is: $config"; 
if ($_SESSION['debug']) print "<div class=\"debug\">($cfgitem)</div>";
else print "<br>"; 
print "<br>";

/* display 'config file' widget */ 
print '<form method=post action="weathermanage.php">'; 
print '<select name="configitem">'; 

if (count($confs) == 0) {
  print '<option value="noconf">[ NONE CREATED ]';
}
else {
  $i=1; 
  foreach($confs as $conf) {
    if (strcmp($conf, $config) == 0) {
	$attr = 'selected="selected"';
    }
    else 
      $attr = ""; 
    
    print "<option value=\"conf$i\" $attr >$conf";
    $i++; 
  }
}
print '</select>';

print '<input type="submit" name="option" value="Select">'; 
print '<input type="submit" name="option" value="Delete">'; 
print '<input type="submit" name="option" value="Edit">'; 
print '<input type="submit" name="option" value="Create New">'; 
print '</div><br>';

 
/* 
 * now include choosen view (node / road) default is node 
 * ______________________________________________________
 */ 
if (strcmp($option, "Road View") == 0) {
  
  /* first backup previous node selection if node view */ 
  if (strcmp($_SESSION['lastview'], "node") == 0)
    save_nodes_to_config($_SESSION['prevconfig']);

  /* keep it in mind */
  $_SESSION['lastview'] = "road";

  /* display road panel */
  if (count($confs) == 0) { print "No configuration created.<br>"; } 
  else { include "road.php"; }
    
  /* add button 'device view' */
  print '<center><input type="submit" name="option" value="Device View">'; 
    
}
else if (strcmp($option, "Device View") == 0) {

  /* keep it in mind */
  $_SESSION['lastview'] = "node";

  /* keep the current config too, for backing it up later */ 
  $_SESSION['prevconfig'] = $_SESSION['configitem'];

  /* display devices panel */
  if (count($confs) == 0) { print "No configuration created.<br>"; } 
  else { include "device.php"; }
    
  /* add button 'road view' */
  print '<center><input type="submit" name="option" value="Road View">'; 
    
}


/* if none: option is monitor */
else {


  /* keep it in mind */
  $_SESSION['lastview'] = "graph";

  /* keep the current config too, for backing it up later */ 
  $_SESSION['prevconfig'] = $_SESSION['configitem'];

  /* page include */ 
  include "monitor.php"; 

  print "<br><center>"; 

  
}

/* last widget: the 'generate button' */
print '<input type="submit" name="option" value="Generate"></form></center>'; 


/* display done, close the db */ 
mysql_close(); 

  
/* *** end of page display *** */ 


?>
