<?php 

/*
 * weathermanage_lib.php
 * part of Weathermanage - Mathieu Gilerdet (matam@chokolate.org) 
 *
 * released under the GNU Public License 
 *
 * file containning all functions used on weathermanage.php 
 */ 

/*
 * display a form for creating or editing a config file
 * if $mode == create, a create button will we displayed; 
 * is mode is update, an update button will be displayed. 
 * ($_SESSION contain already all needed data)
 */
function show_conf_form() {

  /* get the $md paramter from session */ 
  $md = $_SESSION['md']; 

  /* prepare field filling and selection -- first get thoses from $_SESSION 
     then, check for NULL field, and fill with default values. */ 
  $mode=$_SESSION['mode']; 
  $confname=$_SESSION['confname'];
  $title=$_SESSION['title'];
  $height=$_SESSION['height']; 
  $width=$_SESSION['width']; 
  $backgndimg=$_SESSION['backgndimg']; 
  $backgndcolor=$_SESSION['backgndcolor']; 
  $timex=$_SESSION['timex']; 
  $timey=$_SESSION['timey']; 
  $timetext=$_SESSION['timetext']; 
  $timefont=$_SESSION['timefont']; 
  $captionx=$_SESSION['captionx']; 
  $captiony=$_SESSION['captiony']; 
  $captiontext=$_SESSION['captiontext']; 
  $captioncolor=$_SESSION['captioncolor']; 
  $captionprec=$_SESSION['captionprec']; 
  $captionfont=$_SESSION['captionfont']; 
  $nodefont=$_SESSION['nodefont']; 
  $nodecolor=$_SESSION['nodecolor'];  
  $linkfont=$_SESSION['linkfont']; 
  $linkwidth=$_SESSION['linkwidth'];
  $linkunit=$_SESSION['linkunit'];  
  $secure=$_SESSION['secure']; 
  if ($mode == NULL) $mode = 1; 
  if ($width == NULL) $width = 1024;
  if ($height == NULL) $height = 600; // don't override this..
  if ($backgndcolor == NULL) $backgndcolor = "FFFFFF"; 
  if ($timex == NULL) $timex = 200; 
  if ($timey == NULL) $timey = 570; 
  if ($timetext == NULL) $timetext = "Created on %b %d %Y at %H:%M:%S"; 
  if ($timefont == NULL) $timefont = 2; 
  if ($captionx == NULL) $captionx = 10; 
  if ($captiony == NULL) $captiony = 400; 
  if ($captioncolor == NULL) $captioncolor = "D5D5D5"; 
  if ($captionprec == NULL) $captionprec = 10; 
  if ($captionfont == NULL) $captionfont = 2;
  if ($captiontext == NULL && $mode == 1) $captiontext = "Traffic"; 
  if ($captiontext == NULL && $mode == 2) $captiontext = "Scale"; 
  if ($nodefont == NULL) $nodefont = 2;
  if ($nodecolor == NULL) $nodecolor = "C2C2C2"; 
  if ($linkfont == NULL) $linkfont = 2;
  if ($linkwidth == NULL) $linkwidth = 5;
  if ($secure == NULL) $secure = 0; 
 

  /* create font labels arrays */ 
  $fonts = array("1" => "Tiny", "2" => "Small", "3" => "Small Bold", "4" => "Medium", "5" => "Big");   
  $units = array("Bits", "Percents");   



  /* show the create form */ 
  print "<div class=create_header>Please enter the Map Identifier:</div>";
  print '<form name="mainform" method=post action="weathermanage.php">';
  print "<input width=300 type=\"text\" name=\"confname\" value=\"$confname\"><br><br>";


  print "<div class=create_header>General Settings:</div>";
  print "<table border=0>"; 


  /* not available on display mode */ 
  if ($md == "create") {
    print "<tr><td><div class=\"formtext\">Mode: </td><td><select name=\"mode\">";
    print "<option value=1>Network";
    $attr = ""; 
    if ($mode == 2) $attr = 'selected="selected"';
    print "<option value=2 $attr>Global monitoring";
    print "</select></td></tr>";

  } 
  print "<tr><td><div class=formtext>Title: </div></td><td><input type=\"text\" name=\"title\" value=\"$title\"></td></tr>"; 
  if ($mode != 2) print "<tr><td><div class=formtext>Width:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"width\" value=\"$width\"></td></tr>"; 
  if ($mode != 2) print "<tr><td><div class=formtext>Height:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"height\" value=\"$height\"></td></tr>"; 
  print "<tr><td><div class=formtext>Background Image File:<br><i>(Leave it empty if none)</td><td><input type=\"text\" name=\"backgndimg\" value=\"$backgndimg\"></td></tr>"; 
  print "<tr><td><div class=formtext>Background Color:<br><i>(Use hex notation)</td><td><input type=\"text\" name=\"backgndcolor\" value=\"$backgndcolor\"></td></tr>"; 

  $attrssl = "" ;
  print "</table>"; 

  if ($secure) $attrssl = 'checked="checked"';
  print "<INPUT type=\"checkbox\" name=\"secure\" value=\"1\" $attrssl>Use SSL connection<br><br>";
  

  print "<div class=create_header>Timestamp Settings:</div>"; 
  print "<table border = 0>"; 
  if ($mode != 2) print "<tr><td><div class=\"formtext\">Position X:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"timex\" value=\"$timex\"></td></tr>"; 
  if ($mode != 2) print "<tr><td><div class=\"formtext\">Position Y:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"timey\" value=\"$timey\"></td></tr>";
  print "<tr><td><div class=\"formtext\">Text: </td><td><input type=\"text\" name=\"timetext\" value=\"$timetext\"></td></tr>"; 
  print "<tr><td><div class=\"formtext\">Font: </td><td><select name=\"timefont\">";
  for ($i=1; $i<6; $i++) {
    if ($i == $timefont) $attr = 'selected="selected"';
    else $attr = "";
    print "<option value=\"$i\" $attr>$fonts[$i]";  
  }
  print "</select></td></tr>";
  print "</table>"; 



  print '<div class=create_header>Scale Settings:</div>'; 
  print "<table border = 0>"; 
  if ($mode != 2) print "<tr><td><div class=\"formtext\">Position X:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"captionx\" value=\"$captionx\"></td></tr>"; 
  if ($mode != 2) print "<tr><td><div class=\"formtext\">Position Y:<br><i>(Auto while using monitoring mode)</i></td><td><input type=\"text\" name=\"captiony\" value=\"$captiony\"></td></tr>";
  print "<tr><td><div class=\"formtext\">Text: </td><td><input type=\"text\" name=\"captiontext\" value=\"$captiontext\"></td></tr>"; 
  print "<tr><td><div class=\"formtext\">Color:<br><i>(Use hex notation)</td><td><input type=\"text\" name=\"captioncolor\" value=\"$captioncolor\"></td></tr>"; 
  print "<tr><td><div class=\"formtext\">Scale Precision:<br><i>(Number of Color Degrees)</i></td><td><input type=\"text\" name=\"captionprec\" value=\"$captionprec\"></td></tr>"; 
  print "<tr><td><div class=\"formtext\">Font: </td><td><select name=\"captionfont\">";
  for ($i=1; $i<6; $i++) {
    if ($i == $captionfont)   $attr = 'selected="selected"';
    else $attr = "";
    print "<option value=\"$i\" $attr>$fonts[$i]";  
  }
  print "</select></td></tr>"; 
  print "</table>"; 



  print "<div class=create_header>Node Settings: </div>";
  print "<table border = 0>"; 
  print "<tr><td><div class=\"formtext\">Font: </td><td><select name=\"nodefont\">";
  for ($i=1; $i<6; $i++) {
    if ($i == $nodefont)   $attr = 'selected="selected"';
    else $attr = "";
    print "<option value=\"$i\" $attr>$fonts[$i]";  
  }
  print "</select></td></tr>";
  print "<tr><td><div class=\"formtext\">Color:<br><i>(Use hex notation)</td><td><input type=\"text\" name=\"nodecolor\" value=\"$nodecolor\"></td></tr>"; 
  print "</table>"; 



  print "<div class=create_header>Link Settings: </div>";
  print "<table border = 0>"; 
  print "<tr><td><div class=\"formtext\">Font: </td><td><select name=\"linkfont\">";
  for ($i=1; $i<6; $i++) {
    if ($i == $linkfont)   $attr = 'selected="selected"';
    else $attr = "";
    print "<option value=\"$i\" $attr>$fonts[$i]";  
  }
  print "</select></td></tr>";
  if ($mode != 2) { 
    print "<tr><td><div class=\"formtext\">Unit: </td><td><select name=\"linkunit\">";
    print "<option value=\"bits\">Bytes ";
    $attr = ""; 
    if ($linkunit == 'percent') $attr = 'selected="selected"';
    print "<option value=\"percent\" $attr>Percents ";
    print "</select></td></tr>"; 
  }
  print "<tr><td><div class=\"formtext\">Link width:<br><i>(1-10)</i></td><td><input type=\"text\" name=\"linkwidth\" value=\"$linkwidth\"></td></tr>";

  print "</table>"; 
  

  print "<div class=create_header><center>"; 

  if ($md == "update") {
    print "<input type=\"submit\" name=\"option\" value=\"Update\">"; 
  }
  else {
    print "<input type=\"submit\" name=\"option\" value=\"Store\">"; 
  }
  print "<input type=\"submit\" name=\"option\" value=\"Cancel\"></form></center></div>"; 

}










/*
 * store into database config data.
 * two modes: ($_SESSION['md'])
 *  - create (use insert)
 *  - update (use update)  
 */ 
function store_conf() {

  $failed = 0; 


  /* store everything */
  $mode=$_POST['mode']; 
  if ($mode == NULL) $mode = $_SESSION['mode']; 
  $confname=$_POST['confname'];
  $title=$_POST['title'];
  $height=$_POST['height']; 
  $width=$_POST['width']; 
  $backgndimg=$_POST['backgndimg']; 
  $backgndcolor=$_POST['backgndcolor']; 

  $timex=$_POST['timex']; 
  $timey=$_POST['timey']; 
  $timetext=$_POST['timetext']; 
  $timefont=$_POST['timefont']; 

  $captionx=$_POST['captionx']; 
  $captiony=$_POST['captiony']; 
  $captiontext=$_POST['captiontext']; 
  $captioncolor=$_POST['captioncolor']; 
  $captionprec=$_POST['captionprec']; 
  $captionfont=$_POST['captionfont']; 

  $nodefont=$_POST['nodefont']; 
  $nodecolor=$_POST['nodecolor'];  

  $linkfont=$_POST['linkfont']; 
  $linkwidth=$_POST['linkwidth'];
  $linkunit=$_POST['linkunit'];  

  $secure = $_POST['secure']; 

  if ($confname == NULL) {
    print "You must supply a configuration identifier...<br>"; 
    $failed = 1; 
  }

  if ($mode == 2) $height = 0; 
  if (!is_numeric($height) || $height < 0) {
    print "Please insert a positive numeric value to field 'height'<br>";
    $failed = 1; 
  }
  if ($mode == 2) $width = 0; 
  if (!is_numeric($width) || $width < 0)  {
    print "Please insert a positive numeric value to field 'width'<br>";
    $failed = 1; 
  }
  if (!iscolor($backgndcolor) || $backgndcolor == NULL) {
    print "Please fill the background color with a valid value (such as FF00FF)<br>";
    $failed = 1; 
  } 
  if ($mode == 2) $timex = 0; 
  if (!is_numeric($timex) || $timex < 0) {
    print "Please insert a positive numeric value to field 'timestamp x-coordinate'<br>";
    $failed = 1; 
  }
  if ($mode == 2) $timey = 0; 
  if (!is_numeric($timey) || $timey < 0) {
    print "Please insert a positive numeric value to field 'timestamp y-coordinate'<br>";
    $failed = 1; 
  }
  if ($mode == 2) $captionx = 0; 
  if (!is_numeric($captionx) || $captionx < 0) {
    print "Please insert a positive numeric value to field 'scale x-coordinate'<br>";
    $failed = 1; 
  }
  if ($mode == 2) $captiony = 0; 
  if (!is_numeric($captiony) || $captiony < 0) {
    print "Please insert a positive numeric value to field 'scale y-coordinate'<br>";
    $failed = 1; 
  }
  if (!iscolor($captioncolor) || $captioncolor == NULL) {
    print "Please fill the scale background color with a valid value (such as FF00FF)<br>";
    $failed = 1; 
  } 
  if (!is_numeric($captionprec) || $captionprec <= 0) {
    print "Please insert a positive numeric value to field 'scale precision'<br>";
    $failed = 1; 
  }
  if (!iscolor($nodecolor) || $nodecolor == NULL) {
    print "Please fill the background color with a valid value (such as FF00FF)<br>";
    $failed = 1; 
  } 
  if (!is_numeric($linkwidth) || $linkwidth <= 0) {
    print "Please insert a positive numeric value to field 'link width' <br>";
    $failed = 1; 
  }
  if ($mode == 2) $linkunit = ''; 
  if ($secure == NULL) $secure = 0; 


  /* if failure: store data on $_SESSION, and resend */ 
  if ($failed) {
    $_SESSION['mode'] = $mode; 
    $_SESSION['confname'] = $confname;
    $_SESSION['title'] = $title;
    $_SESSION['height'] = $height; 
    $_SESSION['width'] = $width;
    $_SESSION['backgndimg'] = $backgndimg;
    $_SESSION['backgndcolor']=$backgndcolor; 
    
    $_SESSION['timex']=$timex; 
    $_SESSION['timey']=$timey;
    $_SESSION['timetext']=$timetext; 
    $_SESSION['timefont']=$timefont; 
    
    $_SESSION['captionx']=$captionx; 
    $_SESSION['captiony']=$captiony; 
    $_SESSION['captiontext']=$captiontext; 
    $_SESSION['captioncolor']=$captioncolor; 
    $_SESSION['captionprec']=$captionprec; 
    $_SESSION['captionfont']=$captionfont; 
    
    $_SESSION['nodefont']=$nodefont; 
    $_SESSION['nodecolor']=$nodecolor;  
    
    $_SESSION['linkfont']=$linkfont; 
    $_SESSION['linkwidth']=$linkwidth;
    $_SESSION['linkunit']=$linkunit;  
    
    $_SESSION['secure']=$secure; 


    /* escape plan */ 
    return 0; 
  }

  
  /* now insert all */
  if ($_SESSION['md'] == "create") {

    /* create */
    $query="insert into weathermap_conf (mode, name, title, height, width, backgndimg, backgndcolor, timex, timey, timetext, timefont, captionx, captiony, captiontext, captioncolor, captionprec, captionfont, nodefont, nodecolor, linkfont, linkwidth, linkunit, secure) values ($mode, '$confname', '$title', $height, $width, '$backgndimg', '$backgndcolor', $timex, $timey, '$timetext', $timefont, $captionx, $captiony, '$captiontext', '$captioncolor', $captionprec, $captionfont, $nodefont, '$nodecolor', $linkfont, $linkwidth, '$linkunit', $secure)";
    $res = mysql_query($query);
    if ($res == NULL) houston($query);

       
    /* will set insered element as current config after page reload */  
    $query="select id from weathermap_conf";
    $result = mysql_query($query);
    $count = 0;
    while ($record = mysql_fetch_array($result)) {
      $count++; 
    }
    $_SESSION['configitem'] = "conf$count";  
    
    
    /* clean the session */ 
    unset($_SESSION['md']); 
    
  }
  else {

    /* get conf id */
    $query = "select id from weathermap_conf group by id asc";
    $result = mysql_query($query); 
    $index = substr($_SESSION['configitem'], 4, 1);    
    for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
    $id = $record['id']; 

    /* update */ 
    $query="update weathermap_conf set mode = $mode, name = '$confname', title = '$title', height = $height, width = $width, backgndimg = '$backgndimg', backgndcolor = '$backgndcolor', timex = $timex, timey = $timey, timetext = '$timetext', timefont = $timefont, captionx = $captionx, captiony = $captiony, captiontext = '$captiontext', captioncolor = '$captioncolor', captionprec = $captionprec, captionfont = $captionfont, nodefont = $nodefont, nodecolor = '$nodecolor', linkfont = $linkfont, linkwidth = $linkwidth, linkunit = '$linkunit', secure = $secure where id = $id";
   
    $res = mysql_query($query); 
    if ($res == NULL) houston($query); 

    /* and re-select it (conf index may have changer on html form) */ 
    $query = "select id from weathermap_conf group by id asc";
    $result = mysql_query($query); 
    $found = 0; 
    $count = 1;
    while ($rec = mysql_fetch_array($result)) {

      if ($rec['id'] == $id) 
      	$found = 1; 
      else 
	if (!$found) $count++; 
    }
    $_SESSION['configitem'] = "conf$count"; 
    
  }

  /* if store successfull, unset $_SESSION */
  unset_conf_form(); 
  unset($_SESSION['md']); 

  return 1; 

}




/*
 * clear all configuration session vars, 
 * preventing values beeing keeped next time th form will be dosplayed... 
 */
function unset_conf_form() {

  unset( $_SESSION['mode']);
  unset( $_SESSION['confname']);
  unset( $_SESSION['title']);
  unset( $_SESSION['height']); 
  unset( $_SESSION['width']);
  unset( $_SESSION['backgndimg']);
  unset( $_SESSION['backgndcolor']); 
  unset( $_SESSION['timex']); 
  unset( $_SESSION['timey']);
  unset( $_SESSION['timetext']); 
  unset( $_SESSION['timefont']); 
  unset( $_SESSION['captionx']); 
  unset( $_SESSION['captiony']); 
  unset( $_SESSION['captiontext']); 
  unset( $_SESSION['captioncolor']); 
  unset( $_SESSION['captionprec']); 
  unset( $_SESSION['captionfont']); 
  unset( $_SESSION['nodefont']); 
  unset( $_SESSION['nodecolor']);  
  unset( $_SESSION['linkfont']); 
  unset( $_SESSION['linkwidth']);
  unset( $_SESSION['linkunit']);  
  unset( $_SESSION['secure']);  

}




/*
 * the init function:
 * get the database passwd, 
 * then syncronise known nodes with the cacti db
 */ 
function init() {

  if ($_SESSION['debug']) print "<div class=\"debug\">(re)-init...<br></div>";  
  
  /* 
   * getting login & pass from config file
   */
  $file = file("../../include/config.php");
  $found = 0;
  $i = 0; 
  while ($found != 4) {
    $line = $file[$i]; 
    if (preg_match('/\\s?\$database_username\\s?=\\s?[\'"](.*)[\'"]\\s?;/', $line, $matches)) {
      $cactilogin="$matches[1]";
      $found++; 
    }
    if (preg_match('/\\s?\$database_password\\s?=\\s?[\'"](.*)[\'"]\\s?;/', $line, $matches)) {
      $cactipass="$matches[1]";
      $found++; 
    }
    if (preg_match('/\\s?\$database_default\\s?=\\s?[\'"](.*)[\'"]\\s?;/', $line, $matches)) {
      $cactidb="$matches[1]";
      $found++; 
    }
    if (preg_match('/\\s?\$database_hostname\\s?=\\s?[\'"](.*)[\'"]\\s?;/', $line, $matches)) {
      $cactihost="$matches[1]";
      $found++; 
    }

    /* failure... */
    $i++; 
    if ($i == count($file)) {
      print "Unable to find mysql login informations... Aborting.<br>";  
      die; 
    }
  }

  /* push data into session array */ 
  $_SESSION['my_login'] = $cactilogin; 
  $_SESSION['my_pass'] = $cactipass; 
  $_SESSION['my_host'] = $cactihost; 
  $_SESSION['my_db'] = $cactidb; 




  /* connect to mysql db */
  $link = mysql_connect($cactihost,$cactilogin,$cactipass);
  if (!$link) {
    die('Unable to connect database... ' . mysql_error());
  } 
  $db = mysql_select_db($cactidb, $link);
  if (!$db) {
    die ('Unable to use specified datbase... ' . mysql_error());
  }

}



/*
 * function for syncing weathermap device database with 
 * found traffic rrd. 
 *
 */ 
function sync() {
  
    
  if ($_SESSION['debug']) print "<div class=\"debug\">searching for available traffic sources...<br></div>"; 
  $_SESSION['reload'] = 1;

  
  /*
   * flush cache, for preventing bads selection, on device miss 
   */ 
  $query = "select id from weathermap_conf"; 
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  while ($rec = mysql_fetch_array($res)) {
    $id = $rec["$id"]; 
    unset($_SESSION["selected_nodes_$id"]); 
  }

  /*
   * delete all nodes not associated with a config 
   */ 
  $query="delete from weathermap_node where conf = 0"; 
  $result = mysql_query($query);
  if ($result == NULL) houston($query); 

  /* now get the list of availaible rrd graphs */ 
  $query = "select name_cache, name from data_template_data where name_cache like '% Traffic %' and name_cache not like '%voice%' and name_cache not like '%tun%' and name_cache not like '%/lo'"; 
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  while ($rec = mysql_fetch_array($res)) {

    $title = $rec['name_cache']; 
    $template = $rec['name']; 
    $data = explode(" - Traffic - ", $title); 
    $hostdesc = $data[0]; 
    
    /* sometime, titles provide details about interface... get them, according to cacti data query template: 
     * |query_ifIP| - |query_ifName|
     * |query_ifName| 
     * |query_ifIP|/|query_ifDescr| 
     * |query_ifDescr| 
     */


    if ($template == '|host_description| - Traffic - |query_ifIP| - |query_ifName|') {
      $details = explode(" - ", $data[1]);
      $ifdetails = "$details[0]";
      $ifname = "$details[1]"; 
    }
    else if ($template == '|host_description| - Traffic - |query_ifIP|/|query_ifDescr|') {
      $details = explode("/", $data[1]);
      $ifdetails = "$details[0]";
      $ifname = "$details[1]"; 

    }
    else {
      $ifdetails = "";
      $ifname = $data[1]; 
    }

    
    /* get hostneme */ 
    $query = "select hostname from host where description = '$hostdesc'"; 
    $ores = mysql_query($query); 
    if ($ores == NULL) houston($query); 
    $orec = mysql_fetch_array($ores); 
    $host = $orec['hostname'];


    /* do sync */ 
    $query = "insert into weathermap_node (hostname, description, ifname, ifdetails, conf) values ('$host', '$hostdesc', '$ifname', '$ifdetails', 0)"; 
    $ores = mysql_query($query); 
    if ($ores == NULL) houston($query); 
    
  }
}
  






/*
 * delete from weathermap db 
 * a config identified by an item 
 */
function delete_conf($item) {
  
  if ($item != "noconf") {
    
    /* get id from index... */
    $index = substr($item, 4, 2); 
    
    $query="select id from weathermap_conf order by id asc";
    $result = mysql_query($query); 
    for ($i=0; $i<$index; $i++) {
      $record = mysql_fetch_array($result);
    }
    $id = $record['id'];
        
    /* delete matched conf from all tables*/
    $query="delete from weathermap_conf where id = $id";
    $res = mysql_query($query);
    if ($res == NULL) houston($query); 

    $query="delete from weathermap_node where conf = $id";
    $res = mysql_query($query);
    if ($res == NULL) houston($query); 

    $query="delete from weathermap_road where conf = $id";
    $res = mysql_query($query);
    if ($res == NULL) houston($query); 
  
    $query="delete from weathermap_graph where conf = $id";
    $res = mysql_query($query);
    if ($res == NULL) houston($query); 

    /* set the first element as current config after page reload */  
    $query="select id from weathermap_conf";
    $res = mysql_query($query);
    if ($res == NULL) houston($query); 
    if ($record = mysql_fetch_array($res)) {
      $_SESSION['configitem'] = "conf1";  
    }
    else {
      $_SESSION['configitem'] = "noconf"; 
    }
    
    /*  do a sync... can be a bad idea, and will clear the cache */ 
    sync(); 
  }
}





/*
 * function for saving the current nodes selection 
 * on given config. 
 */
function save_nodes_to_config($config) {
 
  /* do nothing if nothing to do! */ 
  if ($config == "noconf") return;

  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  if ($result == NULL) houston($query); 
  $index = substr($config, 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id']; 
  
  /* delete all out dated node entries. */
  $query = "delete from weathermap_node where conf = $id";
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 

  /* for each node, checks if enabled, 
   * on case it is, add a record to db, 
   * and cache config, for display faster next time */
  $nodes = $_SESSION['nodes'];

  for ($i=0; $i<count($nodes); $i++) {
    if ($_POST["iface$i"] == 1) {
      $vals = explode("<>", $nodes[$i]);  
      $query = "insert into weathermap_node (hostname, description, ifname, ifdetails, conf) values ('$vals[0]', '$vals[1]', '$vals[2]', '$vals[3]', $id)"; 
      $res2 = mysql_query($query); 
      if ($res2 == NULL) houston($query); 
    }
  }
}





/*
 * function for saving the current graphs selection 
 * on given config. 
 */
function save_graphs_to_config($config) {

  /* do nothing if nothing to do! */ 
  if ($config == "noconf")  return;

  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  if ($result == NULL) houston($query); 
  $index = substr($config, 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id']; 
  
  /* delete all out dated node entries. */
  $query = "delete from weathermap_graph where conf = $id";
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 

  /* now get the graph list */ 
  $max=$_SESSION["maxitems"];
  
  for ($i=1; $i <= $max; $i++) {

    $name = $_POST["item$i"]; 
    if ($name != NULL) {
  
      $threshold = $_POST["threshold$i"]; 
      
      /* checks for non numericals values of threshold */
      if (!is_numeric($threshold)) {
	$unit = substr($threshold, strlen($threshold) - 1);
	$intpart = substr($threshold, 0, strlen($threshold) - 1); 
	if (!is_numeric($intpart)) $threshold = 1; 
	if ($unit != 'K' && $unit != 'k' && $unit != 'M' && $unit != 'm' && $unit != 'G' && $unit != 'g') $threshold = 1; 
	
      }
      else {
	if ($threshold <= 0) $threshold = 1; 
      }
    

      /* now update db */ 
      $query = "insert into weathermap_graph (name, conf, threshold) values ('$name', $id, '$threshold')"; 
      $res = mysql_query($query); 
      if ($res == NULL) houston($query); 
    }
  } 
}




/*
 * add a new road
 * display a little form asking for node1, node2, 
 * rrd source node. 
 *
 * it is possible to set one or two nodes as a 'passive node'.
 * (if there is any interest setting two nodes as passive) 
 */ 
function add_new_road() {

  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  $index = substr($_SESSION['configitem'], 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id'];

  /* get the list of all available devices */ 
  $query = "select hostname, ifname from weathermap_node where conf = $id";
  $result = mysql_query($query); 
  $available = array();  
  while ($record = mysql_fetch_array($result)) {
    $host = $record['hostname']; 
    $name = $record['ifname']; 
    $node = "$host $name"; 
    array_push($available, $node);
  } 

  /* add all passive nodes found (for this conf) */ 
  $passive = array(); 
  $query = "select node1 from weathermap_road where node1 like '[PASSIVE] %'";  
  $res = mysql_query($query); 
  while ($rec = mysql_fetch_array($res)) {
    $sw = $rec['node1']; 
    if (!in_array($sw, $passive)) array_push($passive, $sw); 
  }
  $query = "select node2 from weathermap_road where node2 like '[PASSIVE] %'";  
    $res = mysql_query($query); 
  while ($rec = mysql_fetch_array($res)) {
    $sw = $rec['node2']; 
    if (!in_array($sw, $passive)) array_push($passive, $sw); 
  }
  foreach($passive as $p) array_push($available, $p);  
  
  /* add the 'new passive node' option */ 
  array_push($available, "New Passive Node");
   
  /* show form */
  print '<form method=post action="weathermanage.php">'; 
  print "Select the bounds of the road:<br>"; 
  print '<select name="node1">'; 
  $i=1; 
  foreach($available as $nd) {
    print "<option value=\"$nd\">$nd";
    $i++; 
  }
  print '</select>';
  print '<select name="node2">'; 
  $i=1; 
  foreach($available as $nd) {
    print "<option value=\"$nd\">$nd";
    $i++; 
  }
  print '</select><br><br>';
  
  print "Select which one will be use as data source:<br>"; 
  print '</select>';
  print '<select name="source">'; 
  print "<option value=\"1\">the first";
  print "<option value=\"2\">the second";
  print '</select><br><br>';
  print '<input type="submit" name="option" value="Store">'; 
  print '<input type="submit" name="option" value="Cancel">'; 
  print '</form>'; 

  /* reset a session verable used later */ 
  $_SESSION['need_one_more']=0; 
 
}









/* 
 * store into database data retrived from 
 * add new road form. */ 
function store_road() {


  /* from add road from */ 
  if ($_POST['node1'] && $_POST['node2']) {
    $_SESSION['node1'] = $_POST['node1']; 
    $_SESSION['node2'] = $_POST['node2']; 
    $_SESSION['source'] = $_POST['source']; 
  }

  /* from passive node naming form */
  else {
    $passive = $_POST['passivenode'];
    
    /* passive is empty, show one more form... */ 
    if ($passive == "") {
      print "Please enter something...<br>"; 
      print "<form method=post action='weathermanage.php'>"; 
      print '<input type="text" name="passivenode"><br><br>';
      print '<input type="submit" name="option" value="Store">'; 
      print "<form>"; 
      exit; 
    }
    

    /* if only one, override it */ 
    if (!(strcmp($_SESSION['node1'], "New Passive Node") == 0 && strcmp($_SESSION['node2'], "New Passive Node") == 0)) {

      /* is node1 or node2 */
      if (strcmp($_SESSION['node1'], "New Passive Node") == 0) {
	$_SESSION['node1'] = "[PASSIVE] $passive";
      }
      else {
	$_SESSION['node2'] = "[PASSIVE] $passive";
      }
    }
  }


  
  /* should we display the passive node form ?  */ 
  if (strcmp($_SESSION['node1'], "New Passive Node") == 0 || strcmp($_SESSION['node2'], "New Passive Node") == 0) {
    
    /* show form */ 
    print '<form method=post action="weathermanage.php">'; 
    print 'Please enter a name describing '; 
        
    /* special case: this the second time, form is displayed. ( two passives nodes have 
       been get */
    if ($_SESSION['need_one_more']) {
      
      print 'the Second Passive node:<br>';
      
      /* passive node 1 is get, and updated */ 
      $_SESSION['node1'] = "[PASSIVE] $passive";
    }

    /* other special case: we get two passive node. We display form for the first time */ 
    if (strcmp($_SESSION['node1'], "New Passive Node") == 0 && strcmp($_SESSION['node2'], "New Passive Node") == 0) {
      
      /* next time, form again */ 
      $_SESSION['need_one_more'] = 1;
      print 'the first Passive Node:<br>';
    
    } 
    
    /* last special case only one passive node has been dropped. */ 
    else if ((strcmp($_SESSION['node1'], "New Passive Node") == 0 || strcmp($_SESSION['node2'], "New Passive Node") == 0) && !$_SESSION['need_one_more']) {
      print 'the Passive Node:<br>';
      $n1 = $_SESSION['node1'];
      $n2 = $_SESSION['node2']; 
    }

    /* display end of form */ 
    print '<input type="text" name="passivenode"><br><br>';
    print '<input type="submit" name="option" value="Store">'; 
    print '</form>';

    mysql_close(); 
    exit; 

  }
  

  /* ** end of form ** */ 


  /* passive node case: one more to store */ 
  if ($passive != "") {
    
    /* is node1 or node2 */
    if (strcmp($_SESSION['node1'], "New Passive Node") == 0) {
      $_SESSION['node1'] = "[PASSIVE] $passive"; 
    }

    if (strcmp($_SESSION['node2'], "New Passive Node") == 0) { 
      $_SESSION['node2'] = "[PASSIVE] $passive"; 
    }
  }    

  $node1=$_SESSION['node1'];
  $node2=$_SESSION['node2'];
  $source=$_SESSION['source']; 
  
  
  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  $index = substr($_SESSION['configitem'], 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id']; 
   
  /* proceed (if not already exists) */
  $query = "select id from weathermap_road where (node1 = '$node1' and node2 = '$node2')"; 
  $res = mysql_query($query);
  if (!mysql_fetch_array($res)) {
    
    /* may happen, and, it isnt a user bug */ 
    if ($source == "") $source = 1;  
    
    $query = "insert into weathermap_road (node1, node2, noderrd, available, conf) values ('$node1', '$node2', $source, 1, $id)"; 
    $res = mysql_query($query); 

    if ($res == NULL) houston($query);
  }
}











/*
 * delete the selected roads 
 */ 
function delete_roads() {

  /* parse, and get roads to delete */ 
  $roads = array(); 
  foreach ($_POST as $key => $val) {
    $key = substr($key, 0 ,4);
    if (strcmp($key, "road") == 0) {
      array_push($roads, $val);     
    }
  }

  /* get conf id */ 
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  $index = substr($_SESSION['configitem'], 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id']; 

  /* for each road, find the road-id, and delete */  
  foreach ($roads as $road) {
    $data = explode("|", $road); 
    $node1 = $data[0]; 
    $node2 = $data[1];
    $query = "select id from weathermap_road where (conf = $id and node1 = '$node1' and node2 ='$node2')";
    $res = mysql_query($query);
    $rec = mysql_fetch_array($res); 
    $rid = $rec['id']; 
    $query = "delete from weathermap_road where id = $rid";  
    mysql_query($query); 
  }
}










/*
 * the config generation fonction. 
 * write a text file into weathermap configs folder
 */
function generate() {

  /* get config id */ 
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query); 
  if ($result == NULL) houston($query); 
  $index = substr($_SESSION['configitem'], 4, 1);    
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id'];

  /* get data from config */ 
  $query = "select * from weathermap_conf where id = $id";
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  $rec = mysql_fetch_array($res); 
  $confname=$rec['name'];
  $title=$rec['title'];
  $height=$rec['height']; 
  $width=$rec['width'];
  $backgndimg=$rec['backgndimg'];
  $backgndcolor=$rec['backgndcolor']; 
  $timex=$rec['timex']; 
  $timey=$rec['timey'];
  $timetext=$rec['timetext']; 
  $timefont=$rec['timefont']; 
  $captionx=$rec['captionx']; 
  $captiony=$rec['captiony']; 
  $captiontext=$rec['captiontext']; 
  $captioncolor=$rec['captioncolor']; 
  $captionprec=$rec['captionprec']; 
  $captionfont=$rec['captionfont']; 
  $nodefont=$rec['nodefont']; 
  $nodecolor=$rec['nodecolor'];  
  $linkfont=$rec['linkfont']; 
  $linkwidth=$rec['linkwidth'];
  $linkunit=$rec['linkunit'];  
  $secure=$rec['secure']; 
  $mode=$rec['mode'];  

  /* we dont want filenames with spaces */ 
  $confname = strtr($confname, " ", "_");
  $confname = "$confname.conf";

  /* get cacti root path */ 
  $query = "select value from settings where name = 'path_webroot'";
  $res = mysql_query($query); 
	
  if ($res == NULL) houston($query);
  $rec = mysql_fetch_array($res);
  $cactiroot = $rec['value']; 

  /* set file name */ 
  $filename = "$cactiroot/plugins/weathermap/configs/$confname"; 

  /* first thing: does already exists this config? 
   * if yes, backup it: we will try to match th epositions later... 
   */ 
   if (file_exists($filename)) {

     $file = file($filename);  
  
     /* now make the backup small: if 40 nodes, tab will be parsed 40 times... */ 
     $bak = array(); 
     foreach ($file as $line) {
       if (preg_match("/.*(NODE |POSITION ).*/i", $line, $matches)) array_push($bak, $line); 
     }
   }


  /* prepare a file for writing. */ 
  $fd = fopen("$filename","w"); 
  if (!$fd) {
    print "Cannot open $confname for writing... please check the weathermap 'configs' folder."; 
    return; 
  }


  /* if its a monitoring conf, size, and other things will be according to number of devices */ 
  if ($mode == 2) {
    $width = 1200; 
    $height = get_render_height(); 
    $timex = 6; 
    $timey = 12; 
    $captiony = $height - 195; 
    if ($height % 400 == 0) $captionx = 1100; 
    else $captionx = 5; 
  }

    
  /* file and data are ready: write global section */ 
  fwrite($fd, "### \n");
  fwrite($fd, "# $confname\n");
  fwrite($fd, "# ________________________________\n");
  fwrite($fd, "# configurtion file for weathermap\n");
  fwrite($fd, "# generated by weathermanage.php  \n");
  fwrite($fd, "# ________________________________\n");
  fwrite($fd, "\n"); 
  fwrite($fd, "# [ global section ]\n"); 
  fwrite($fd, "TITLE $title\n");
  fwrite($fd, "WIDTH $width\n");
  fwrite($fd, "HEIGHT $height\n");
  fwrite($fd, "HTMLSTYLE overlib\n");
  if ($backgndimg != NULL)
    fwrite($fd, "BACKGROUND $backgndimg\n");
  else
    fwrite($fd, "BGCOLOR " . color_value($backgndcolor) . "\n");
  fwrite($fd, "\n");
  fwrite($fd, "# [ timestamp section ]\n");
  fwrite($fd, "TIMEPOS $timex $timey $timetext\n");
  fwrite($fd, "TIMEFONT $timefont\n");
  fwrite($fd, "TIMECOLOR 0 0 0\n");
  fwrite($fd, "\n");
  fwrite($fd, "# [ scale section ]\n");
  fwrite($fd, "KEYPOS $captionx $captiony $captiontext\n");
  fwrite($fd, "KEYFONT $captionfont\n");
  fwrite($fd, "KEYTEXTCOLOR  0 0 0\n");
  fwrite($fd, "KEYBGCOLOR " . color_value($captioncolor) . "\n");

  
  /* draw a gradient: $captionprec contains the number of wanted colored degree  
   * colors go from purple (8000FF) to red (FF0000).
      - purple to blue: 8000FF to OOOOFF  (1/2 step)
      - blue to cyan: OOOOFF to OOFFFF  (one step) 
      - cyan to green: OOFFFF to 00FF00  (one step)
      - green to yellow: 00FF00 to FFFF00  (one step) 
      - yellow to red: FFFF00 to FF0000  (one step) 
      
      so we get a 4.5 steps path... (9 will be more easier) 
      for each degree, we just define its position to the path.
      degree / 9 give the step.  according to the step, its easy to 
      determine color code. 
  */  


  $scale = 100 / $captionprec; 
  for ($i=0; $i<$captionprec; $i++) {
    $b1 = round( $i * $scale );
    $b2 = round( ($i + 1) *  $scale );
   

    /* we don't whan begining at 0: map become more representative */ 
    if ($b1 == 0) $b1++; 
    if ($b2 > 100) $b2=100;
  
    /* find witch step */ 
    $step = $i / ($captionprec - 1) * 9; 
    
    
    /* purple to blue */ 
    if ($step <= 1) {
      $red = 128 - round($step/2 * 255);
      if ($red < 10) $red = 10; 
      $green = 0; 
      $blue = 255; 
    }

    /* blue to cyan */ 
    else if ($step <= 3) {
      $step = $step - 1; 
      $red = 0; 
      $green = round($step/2 * 255);
      if ($green > 245) $green = 245;  
      $blue = 255; 
    }
    
    /* cyan to green */ 
    else if ($step <= 5) {
      $step = $step - 3; 
      $red = 0; 
      $green = 255;
      $blue = 255 - round($step/2 * 255); 
      if ($blue < 10) $blue = 10; 
    }
    
    /* green to yellow */ 
    else if ($step <= 7) {
      $step = $step - 5; 
      $red = round($step/2 * 255);
      if ($red > 245) $red = 245;  
      $green = 255;
      $blue = 0;
    }

    /* yellow to red */ 
    else {
      $step = $step - 7; 
      $red = 255;
      $green = 255 - round($step/2 * 255);
      if ($green < 10) $green = 10; 
      $blue = 0;
    }
    fwrite($fd, "SCALE $b1 $b2 $red $green $blue\n");
  }
  fwrite($fd, "\n");
  fwrite($fd, "# [ nodes/link default definition ]\n");
  fwrite($fd, "LINK DEFAULT\n");
  if ($mode == 1) fwrite($fd, "  BWLABEL $linkunit\n");
  else fwrite($fd, "  BWLABEL bits\n");
  fwrite($fd, "  BWFONT $linkfont\n");
  fwrite($fd, "  WIDTH $linkwidth\n");
  fwrite($fd, "\n");
  fwrite($fd, "NODE DEFAULT\n");
  fwrite($fd, "  LABELBGCOLOR " . color_value($nodecolor) . "\n");
  fwrite($fd, "  LABELFONT $nodefont\n");


  /* now write a type of conf, according to the confoguration mode choosen:
   * network or monitoring */ 
  if ($mode == 1) generate_network($fd, $id, $cactiroot, $confname, $secure, $width, $height, $bak);
  else generate_monitoring($fd, $id, $cactiroot, $confname, $secure); 
 
}




/* part II of generation: 
 * network case */ 
function generate_network($fd, $id, $cactiroot, $confname, $secure, $width, $height, $bak) {


  /* 
   * now will write the node list *
   */
  fwrite($fd, "\n");
  fwrite($fd, "# [ nodes ]\n");

  /* get all nodes from road which will be displayed 
     add them into an array */
  $query = "select node1, node2 from weathermap_road where conf = $id and available = 1";
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  $nodes = array(); 
  while ($rec = mysql_fetch_array($res)) {
    $node1 = $rec['node1']; 
    $node2 = $rec['node2']; 


    /* if node is not passive, we get 'name interface'. snip interface: a node with several interface 
       will be displayed one time. */ 
    if (strcmp(substr($node1, 0, 9), "[PASSIVE]") != 0) {
      $nd = explode(" ", $node1);
      $node1 = $nd[0]; 
    }
    if (strcmp(substr($node2, 0, 9), "[PASSIVE]") != 0) {
      $nd = explode(" ", $node2);
      $node2 = $nd[0]; 
    }
    if (!in_array($node1, $nodes)) array_push($nodes,  $node1);  
    if (!in_array($node2, $nodes)) array_push($nodes,  $node2);  
  }
  $count = count($nodes); 
  

  /* checks divide by 0 */ 
  if ($count != 1) {
    $x = 100;
    $dx = ($width - 200) / ($count - 1);
    if ($dx < 0) $dx = $width / ($count - 1);

    $y = 100;
    $dy = ($height - 200) / ($count - 1);
    if ($dy < 0) $dy = $height / ($count - 1);

  }
  else {
    $x = $width / 2; 
    $y = $height / 2; 
    $dx = 0; 
    $dy = 0; 
  }
   
  /* browse each road */ 
  foreach ($nodes as $node) {
    
    /* passive or not? */ 
    if (strcmp(substr($node, 0, 9), "[PASSIVE]") == 0) {
      $desc = substr($node, 10, 1024);
      $node = strtr($desc, " ", "_");; 

    }
    else {   
      $query = "select description from host where hostname = '$node'"; 
      $res2 = mysql_query($query); 
      if ($res2 == NULL) houston($query); 
      $rec2 = mysql_fetch_array($res2); 
      $desc = $rec2['description']; 
    }
    
    
    
    /* now try to find a position, if a backup file exists... */ 
    if (count($bak) > 0) {

       $failed = 0; 
       $gethost = 0; 
       $found = 0;
       $i = 0; 
       while (!$found && !$failed && $i < count($bak)) {
	
     	 $line = $bak[$i]; 
	 if (preg_match("/^\s*NODE $node/i", $line, $matches)) {
	   $gethost = 1; 
	 }
	 else if ($gethost) {

	   if (preg_match("/^\s*NODE (.*)/i", $line, $matches)) { 
	     $failed = 1; 
	   } 
	   else {
	     if (preg_match("/^\s*POSITION\s+(\d+)\s+(\d+)/i", $line, $matches)) {
	       $x="$matches[1]";
	       $y="$matches[2]";
	       $found = 1; 
	     }
	   }
	 }
	 $i++; 
       }
    }
    

    fwrite($fd, "NODE $node\n");
    fwrite($fd, "  LABEL $desc\n");
    fwrite($fd, "  POSITION $x $y \n");
    fwrite($fd, "\n");
    $x = round($x + $dx);
    $y = round($y + $dy);

  }



  /*
   * finally, write the links list *
   */ 
  
	
  /* log errors while generation */ 
  $errors = 0 ; 
  $log = array(); 
	


  /*
   * now, browse each road, and create link 
   */ 
  $query = "select * from weathermap_road where available = 1 and conf = $id";
  $mainres = mysql_query($query);
  if ($mainres == NULL) houston($query);
  while ($mainrec = mysql_fetch_array($mainres)) {
    $node1 = $mainrec['node1'];
    $node2 = $mainrec['node2']; 
    $source = $mainrec['noderrd'];
    $speed = -1; 
    $write_speed = 0; 
    
    /* get first word: is '[PASSIVE]' or the hostname */ 
    $nd1 = explode(" ", $node1);  
    $nd2 = explode(" ", $node2);  

    if (strcmp($nd1[0], "[PASSIVE]") == 0) {
      $node1_is_passive = 1;
      $node1 = substr($node1, 10, 1024);
      $node1 = strtr($node1, " ", "_");
     
    }
    else {
      $write_speed = 1; 
      $node1_is_passive = 0;
      $node1 = "$nd1[0]";
      $iface1 = "$nd1[1]"; 

      /* get speed 
       * for this, we use an snmp script that query the host  
       * if any error, default is set to -1 */ 
      $speed = get_speed($node1, $iface1); 
      if ($speed == -1) {
	array_push($log, "Speed hasn't been set for $node1/$iface1\n"); 
	$errors++; 
      }
    }
  
    /* same for second node */  
    if (strcmp($nd2[0], "[PASSIVE]") == 0) {
      $node2_is_passive = 1;
      $node2 = substr($node2, 10, 1024);
      $node2 = strtr($node2, " ", "_"); 
    }
    else {
      $write_speed = 1; 
      $node2_is_passive = 0;
      $node2 = "$nd2[0]";
      $iface2 = "$nd2[1]"; 
      
      
      /* get speed */ 
      $nd2speed = get_speed($node2, $iface2);
      if ($nd2speed == -1) {
	array_push($log, "Speed hasn't been set for $node2/$iface2\n"); 
	$errors++; 
      }
      if ($speed == -1 || $speed > $nd2speed) $speed = $nd2speed; 
    }

    if ($speed == -1) $write_speed = 0; 
 
    fwrite($fd, "LINK $node1" . "_" . "$node2\n");
    fwrite($fd, "  NODES $node1 $node2\n");
    if ($write_speed) fwrite($fd, "  BANDWIDTH $speed\n"); 
	
    /* node one can be graphed, and has been selected */ 
    $source_it = 0; 


    if ((!$node1_is_passive) && $source == 1) {
      $host = $node1; 
      $iface = $nd1[1]; 
      $source_it = 1; 
    }
    
    else if ((!$node2_is_passive) && $source == 2) {
      $host = $node2; 
      $iface = $nd1[2]; 
      $source_it = 1; 
    }




    /* now, deals with source. 
       we search two things: the graph-id, and the rrd-path (obtained from data-id)
       
       interface traffic graphs are needed for this purpose.
       those graphs are matched thanks to the graph title, containing hostname, and iface, 
       that is owr unique key. */ 
    if ($source_it) {

      
      $query = "select description from host where hostname = '$host'"; 
      $res = mysql_query($query); 
      
      if ($res == NULL) houston($query);
      
      $rec = mysql_fetch_array($res);
      $desc = $rec['description']; 
      if ($desc == NULL) {

	print "<link rel=\"stylesheet\" type=\"text/css\" href=\"weathermanage.css\">";
	print "FATAL: Cannot find description from host $host, aborting...<br>"; 
	sync(); 
	print "Database have been re-synced... It should work now.<br><br>";
	print "<a href=weathermanage.php>Back</a><br>"; 
	exit; 
      }
    
    
      /* have a look around rrd */ 
      $abort = 0; 
      $query = "select data_source_path, local_data_id from data_template_data where name_cache like \"%$desc - Traffic -%$iface%\""; 
   

      
      $res = mysql_query($query); 
      if ($res == NULL) houston($query);
      
      $found = 0; 
      $rec = mysql_fetch_array($res);
      
      if ($res == NULL) {
	$abort = 1;
	$errmsg2 = "# cannot add target: no rrd found for this device ($host $iface)... please add them manually\n";
	array_push($log, "No rrd matched for $host on $iface... please create it"); 
	array_push($log, "> $query\n"); 
	$errors++; 
      }
      
      $path = $rec['data_source_path']; 
      $data_template_id = $rec['data_template_id']; 
      $local_data_id = $rec['local_data_id']; 
      
      
      
      /* some adjustement ;) */ 
      $trans = array("<path_rra>" => "$cactiroot/rra"); 
      $path = strtr($path, $trans);  
      
    
      
      /* now get the graph id  */ 
      if (!$abort) {
      

      
	$query = "select id from data_template_rrd where local_data_id = $local_data_id"; 
	$res = mysql_query($query); 
	if ($res == NULL) houston($query);
	
	$found = 0; 
	while (!$found && $rec = mysql_fetch_array($res)) {
	  $task_item_id = $rec['id']; 
	
	  
	  /* finaly get the graph */ 
	  $query = "select local_graph_id from graph_templates_item where task_item_id = $task_item_id"; 
	  $res2 = mysql_query($query); 
	  if ($res == NULL) houston($query);
	
	  $rec = mysql_fetch_array($res2);
	  $gid = $rec['local_graph_id']; 
	  if ($gid != NULL) $found = 1;
	}

	if (!$found) {
	    $abort = 1; 
	    $errmsg1 = "# cannot add target: no graph found for this device ($host $iface)... please add them manually\n";
	    array_push($log, "No graph matched for $host on $iface... please create it"); 
	    array_push($log, "> $query\n"); 
	    $errors++; 
	}
      }
      
      
      /* writing directives, according to results. if no graphes found, 
	 an error msg is written instead. */ 
      if (!$abort) {
	
	/* write target directive */ 
	fwrite($fd, "  TARGET $path\n");
	
	/* write overlib directive -- please note the DISTANT_SERVER_NAME variable
	   will only work with the weathermap hack. we want our server beeing 
	   reachable with a dynamic ip.  */
	if ($secure) $proto = "https"; 
	else $proto = "http"; 
	
	fwrite($fd, "  OVERLIBGRAPH $proto://DISTANT_SERVER_NAME/cacti/graph_image.php?local_graph_id=$gid&rra_id=1&graph_nolegend=true&graph_height=100&graph_width=300\n");
	
      }
      else {
	fwrite($fd, $errmsg1); 
	fwrite($fd, $errmsg2);
      }
      fwrite($fd, "\n");
    }
  }
  
  fclose($fd);


  /* enable the map */ 
  enable_map($confname); 

  
  /* switch to gaphical editor mode. if any errors, display them first. */ 
  if (!$errors) {
  
    $_SESSION['lastview'] = 'node'; 
    header("Location: ./editor.php?mapname=$confname");
  }
  else {
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"weathermanage.css\">";
    print "<br>"; 
    print "$errors error";
    if ($errors > 1) print "s have";
    else print " has";
    print " been encountered while generation: <br>"; 
    foreach ($log as $line) print "<li> $line <br>";
    print "<br><a href=\"editor.php?mapname=$confname\">Graphical editor</a><br>"; 
    print "<a href=weathermanage.php>Back</a><br>"; 
    exit; 
  } 
  
}



/* part II of generation: 
 * monitoring case */ 
function generate_monitoring($fd, $id, $cactiroot, $confname, $secure) {

  $log = array(); 
  
  /* 
   * now will write the node list *
   */
  fwrite($fd, "\n");
  fwrite($fd, "# [ nodes ]\n");

  /* get all indicators (graphs) we what to see. */ 
  $query = "select * from weathermap_graph where conf = $id order by name"; 
  $mainres = mysql_query($query); 
  if ($mainres == NULL) houston($query); 
  $graphs = array(); 
  while ($mainrec = mysql_fetch_array($mainres)) array_push($graphs, $mainrec['name']); 
  
  /* if no graph return now */ 
  if (count($graphs) == 0) { 
    
    /* close all */ 
    mysql_close();
    fclose($fd); 
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"weathermanage.css\">";
    print "No graphs has been selected... Generation aborted.<br>"; 
    print "<a href=weathermanage.php>Back</a><br>"; 
    exit; 
  }
    

  /* now we ve got a graph list, explode it */ 
  $idx = 1; 
  

  /* init the first array: create it. first element will be hostname description */
  $prec = get_host_desc($graphs[0]); 
  $array = array(); 
  $subarray = array(); 
  array_push($subarray, $prec);  
  

  /* now parse all */ 
  for ($i = 0; $i < count($graphs); $i++) {

     /* get the hostname */ 
    $thisone = get_host_desc($graphs[$i]); 

    /* if new hostname, new array. */ 
    if ($thisone != $prec) {
      $idx++; 

      /* done for thus subarray */ 
      array_push($array, $subarray); 
      unset($subarray); 

      /* reset it */ 
      $subarray = array(); 
      array_push($subarray, $thisone);  
      $prec = $thisone; 
    }

    /* now simply add the graph */ 
    array_push($subarray, $graphs[$i]); 
  }

  /* push the last sub array */ 
  array_push($array, $subarray); 

  
  /* now we have an array for each hostname, and its measures. 
   * calculate postions and write links/node */

  /* init left-top coords for one host */ 
  $x=0;
  $y=0; 

  foreach ($array as $device) {


    $mainnode = strtr($device[0], " ", "_");
    $label = $device[0];
    $nx = $x + 200; 
    $ny = $y + 200; 
    
    /* write host node */ 
    fwrite($fd, "NODE $mainnode\n");
    fwrite($fd, "  LABEL $label\n");
    fwrite($fd, "  POSITION $nx $ny \n");
    fwrite($fd, "\n");


    /* ok, now for each measure, calculate coors, 
       and positions labels around the hostname */ 
    for ($j = 1; $j< count($device); $j++) {


      /* checks if rrd is composed with multiple data sources */ 
      $res = stripos($device[$j], "("); 

      /* simple case: one datesource per rrd */ 
      if ($res === false) {
	
	$name = $device[$j]; 
	
	/* and get data source name */ 
	$query = "select local_data_id from data_template_data where name_cache = '$name'"; 
	$res = mysql_query($query); 
	if ($res == NULL) houston($query);
	$rec = mysql_fetch_array($res);
	$local_data_id = $rec['local_data_id']; 

	$query = "select data_source_name from data_template_rrd where local_data_id = $local_data_id";
	$res = mysql_query($query); 
	if ($res == NULL) houston($query); 
	$rec = mysql_fetch_array($res);
	$datasource = $rec['data_source_name']; 

	/* now get path */ 
	$query = "select data_source_path from data_template_data where name_cache = '$name'"; 
	$res = mysql_query($query); 
	if ($res == NULL) houston($query);
	$rec = mysql_fetch_array($res);
	$path = $rec['data_source_path']; 
      }

      /* several datasources per rrd */ 
      else {

	$name = $device[$j];
	$res = explode(" (", $name); 
	$realname = $res[0]; 

	$datasource = $res[1];
	$datasource = substr($datasource, 0, strlen($datasource) - 1); 

	/* get data source id only */ 
	$query = "select local_data_id from data_template_data where name_cache = '$realname'"; 
	$res = mysql_query($query); 
	if ($res == NULL) houston($query);
	$rec = mysql_fetch_array($res);
	$local_data_id = $rec['local_data_id']; 

	/* now get path */ 
	$query = "select data_source_path from data_template_data where name_cache = '$realname'"; 
	$res = mysql_query($query); 
	if ($res == NULL) houston($query);
	$rec = mysql_fetch_array($res);
	$path = $rec['data_source_path']; 


      }
      
      
      /* next, get threshold value */ 
      $detailled_name = $device[$j]; 
      $query = "select threshold from weathermap_graph where name = '$detailled_name'"; 
      $res = mysql_query($query); 
      if ($res == NULL) houston($query);
      $rec = mysql_fetch_array($res);
      $threshold = $rec['threshold']; 
  
      /* for each data source, look around the associated graph (this query has been a little 'inspired' from cacti code ;) */ 
      $query = "select distinct graph_templates_item.local_graph_id from graph_templates_item
         left join data_template_rrd on graph_templates_item.task_item_id=data_template_rrd.id
         left join graph_templates_gprint on graph_templates_item.gprint_id=graph_templates_gprint.id
         where data_template_rrd.local_data_id = $local_data_id 
	 and data_template_rrd.data_source_name = '$datasource'";  
      
      $res = mysql_query($query); 
      if ($res == NULL) houston($query); 
      $rec = mysql_fetch_array($res);  
      $graphid = $rec['local_graph_id']; 
   
      if ($graphid == "") array_push($log, "unable to find a suitable graph for RRD having id $local_data_id and datasource $datasource.");  
   
            
      /* calc coors */ 
      $coors = array(); 
      $coors = calc_coords($x, $y, $j, count($device) - 1);  

      /* prepare values for writting */ 
      $trans = array("<path_rra>" => "$cactiroot/rra"); 
      $path = strtr($path, $trans);  
      $label = $name; 

      $node = strtr($name, " ", "_");

      /* strip host description */ 
      $pos = strlen($device[0]) + 3;   // ' - '
      $label = substr($label, $pos); 

      /* get an icon according to node description */ 
      if ($graphid != "") {
	$query = "select title from graph_templates_graph where local_graph_id = $graphid";
	$res = mysql_query($query); 
	if ($res == NULL) houston($query); 
	$rec = mysql_fetch_array($res);
	$gtitle = $rec['title']; 
      }

      $pattern = strtolower($label . " " . $gtitle); 
      $icon = ""; 
   
      if (preg_match("/.*apache.*/", $pattern)) {
	$icon = "images/apache.png"; 
      }
      else if (preg_match("/.*(exim|postfix|mail).*/", $pattern)) {
	$icon = "images/mail.png"; 
      }
      else if (preg_match("/.*voltage.*/", $pattern)) {
	$icon = "images/batt.png"; 
      }
      else if (preg_match("/.*temperature.*/", $pattern)) {
	$icon = "images/temp.png"; 
      }
      else if (preg_match("/.*partition.*/", $pattern)) {
	$icon = "images/hd.png"; 
      }
      else if (preg_match("/.*(load|mem).*/", $pattern)) {
	$icon = "images/ram.png"; 
      }
      else if (preg_match("/.*cpu.*/", $pattern)) {
	$icon = "images/cpu.png"; 
      }
      else $icon = "images/default.png"; 

      $link = $node . "_lnk"; 



      /* now, look around the associated cdef. 
       * will write a special directive on the link config */ 
      $query = "select id from data_template_rrd where data_source_name = '$datasource' and local_data_id = $local_data_id"; 
      $res = mysql_query($query); 
      if ($res == NULL) houston($query); 
      $rec = mysql_fetch_array($res); 
      $itemid = $rec['id']; 

      $query = "select cdef_id from graph_templates_item where task_item_id = $itemid order by sequence asc"; 
      $res = mysql_query($query); 
      if ($res == NULL) houston($query); 
      $rec = mysql_fetch_array($res); 
      $cdefid = $rec['cdef_id']; 
      
      /* get the cdef function, and translate it... but keep it on reverse polish */ 
      if ($cdefid != NULL) {
	$query = "select type, value from cdef_items where cdef_id = $cdefid order by sequence asc";
	$res = mysql_query($query); 
	if ($res == NULL) houston($query); 
	$string = "  CDEF";
	$wont_write = 0; 
	while ($rec = mysql_fetch_array($res)) {
	  $type = $rec['type']; 
	  $value = $rec['value']; 
	  
	  /* its an operator */ 
	  if ($type == 2) {
	    if ($value == 1) $string = $string . " +"; 
	    elseif ($value == 2) $string = $string . " -"; 
	    elseif ($value == 3) $string = $string . " *"; 
	    elseif ($value == 4) $string = $string . " /"; 
	    elseif ($value == 5) $string = $string . " %"; 
	    else $wont_write = 1; 
	  }
	  
	  /* its a special cdef element (on most cases, its datasource) */ 
	  else if ($type == 4) {
	    if ($value == 'CURRENT_DATA_SOURCE') $string = $string . " CURRENT_DATA_SOURCE"; 
	    else $wont_write = 1; 
	  }
	  
	  /* its a custom string (including values) */ 
	  else if ($type == 6) {
	    if (!is_numeric($value)) $wont_write = 1; 
	    else $string = $string . " $value";
	  }
	  
	  /* else, its not a simple cdef. */
	  else $wont_write = 1; 
	}
      }
	
      if ($string == "  CDEF") $wont_write = 1;  



      
      


      
      /* and write (tiny font) */ 
      fwrite($fd, "\n"); 
      fwrite($fd, "NODE $node\n");
      fwrite($fd, "  LABEL $label\n");
      $wx = round($coors['x']);
      $wy = round($coors['y']);
      fwrite($fd, "  POSITION $wx $wy \n");
      if ($icon != "") {
	fwrite($fd, "  ICON $icon\n"); 
	fwrite($fd, "  LABELOFFSET S\n"); 
      }
      fwrite($fd, "\n");
      fwrite($fd, "LINK $link\n");
      fwrite($fd, "  NODES $mainnode $node\n");
      fwrite($fd, "  ARROWSTYLE single\n");
      fwrite($fd, "  TARGET $path:$datasource:none\n"); 
      fwrite($fd, "  BANDWIDTH $threshold\n"); 
      if ($graphid != "") fwrite($fd, "  OVERLIBGRAPH https://DISTANT_SERVER_NAME/cacti/graph_image.php?local_graph_id=" . "$graphid" . "&rra_id=1&graph_height=150&graph_width=400\n"); 
      if (!$wont_write) fwrite($fd, "$string \n");
      fwrite($fd, "\n"); 


    } 
    

    /* update left-top coords for one host */  
    $x = $x + 400; 
    if ($x >= 1200) {
      $x = 1; 
      $y = $y + 400;
    }
  }
  
  
 


  /* close all */ 
  fclose($fd); 

  /* enable the map */ 
  enable_map($confname); 

  /* and redirct */ 
  if (count($log) > 0) {
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"weathermanage.css\">";
    print "<div class=notice>The following warnings has been caught while generation:</div><br>";
    $i = 1; 
    while ($i <= count($log)) {
      $line = $log[$i-1]; 
      print "<strong>[$i]</strong> $line<br>";
      $i++; 
    }
    print "<br>";
    print "<a href=\"editor.php?mapname=$confname\">Graphical editor</a><br>"; 
    print "<a href=weathermanage.php>Back</a><br>"; 
    exit; 


  }
  else {
    $_SESSION['lastview'] = 'node'; 
    header("Location: ./editor.php?mapname=$confname");
  }
}



/*
 * display a confirmation form 
 */ 
function  display_delete_confirmation() {

  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query);
  $index = substr($_SESSION['configitem'], 4, 1);
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id'];

  /* prepare $_SESSION */
  $query="select name from weathermap_conf where id = $id";
  $res = mysql_query($query);
  if ($res == NULL) houston($query); 
  $rec = mysql_fetch_array($res);
  $name = $rec['name']; 
  print "<div class=caution>Do you really want purge to config $name?</div><br>";
  print "<form method=post action='weathermanage.php'>"; 
  print "<center><input type=\"submit\" name=\"option\" value=\"Yes\">"; 
  print "<input type=\"submit\" name=\"option\" value=\"No\"></center></form>"; 
  exit; 


}



/* function for edting the config options...
   first prepare the $_SESSION variables,
   then call the create_form */
function edit_config($config) {


  /* get conf id */
  $query = "select id from weathermap_conf group by id asc";
  $result = mysql_query($query);
  $index = substr($config, 4, 1);
  for ($i=0; $i<$index ; $i++) $record = mysql_fetch_array($result);
  $id = $record['id'];

  /* prepare $_SESSION */
  $query="select * from weathermap_conf where id = $id";
  $res = mysql_query($query);
  $rec = mysql_fetch_array($res);
  $_SESSION['mode'] = $rec['mode'];
  $_SESSION['confname'] = $rec['name'];
  $_SESSION['title'] = $rec['title'];
  $_SESSION['height'] = $rec['height'];
  $_SESSION['width'] = $rec['width'];
  $_SESSION['backgndimg'] = $rec['backgndimg'];
  $_SESSION['backgndcolor'] = $rec['backgndcolor'];
  $_SESSION['timex'] = $rec['timex'];
  $_SESSION['timey'] = $rec['timey'];
  $_SESSION['timetext'] = $rec['timetext'];
  $_SESSION['timefont'] = $rec['timefont'];
  $_SESSION['captionx'] = $rec['captionx'];
  $_SESSION['captiony'] = $rec['captiony'];
  $_SESSION['captiontext'] = $rec['captiontext'];
  $_SESSION['captioncolor'] = $rec['captioncolor'];
  $_SESSION['captionprec'] = $rec['captionprec'];
  $_SESSION['captionfont'] = $rec['captionfont'];
  $_SESSION['nodefont'] = $rec['nodefont'];
  $_SESSION['nodecolor'] = $rec['nodecolor'];
  $_SESSION['linkfont'] = $rec['linkfont'];
  $_SESSION['linkwidth'] = $rec['linkwidth'];
  $_SESSION['linkunit'] = $rec['linkunit'];
  $_SESSION['secure'] = $rec['secure'];

  /* and call create_config fonction, with an id a paramter 
     telling mode is edit */ 
  $_SESSION['md'] = "update";  
  show_conf_form();  
   
}






/* simple function for validating a pattern as a color */ 
function iscolor($color) {
  
  if (strlen($color) != 6) return 0;
  for ($i=0; $i<6; $i++) {
    $ch = substr($color, $i, 1); 
    if (!is_numeric($ch)) {
      $ch = strtolower($ch);
      if ($ch != "a" && $ch != "b" && $ch != "c" && $ch != "d" && $ch != "e" && $ch != "f")
	return 0; 
    }
  }
  return 1; 
}

/* simple function for transforming a hex value color to decimal value 
   (FF0000 => 255 0 0) */ 
function color_value($color) {

  $res = ""; 

  for ($i=0; $i<3; $i++) {

    $val = substr($color, ($i*2), 2); 
    $val = hexdec($val); 
    $res = $res . " " . $val; 
  }
  
  return $res; 
}


/* do you like pythagore? me too... 
 * function for retriving coors of a given node. 
 * the params are: 
 *  - x: the device x LEFT COORD. each device has a 340x340 square. this is
 *       the x coor of the square. the device is naturally positionned at the 
 *       centre of the square. 
 *  - y: same for y 
 *  - n: this is the number of the measure. all measures are nodes on an circle
 *       centered on device. we need to know how many measures, 
 *       and, witch one it is. 
 *       numbers start from 1, and grow up to total. 
 *  - measures: this is the total. 
 */ 
function calc_coords($x, $y ,$n, $measures) {

  $res = array("x" => 0, "y" => 0);
  
  
  /* the distance of a measure from from center */ 
  $distance = 145; 

  /* calc the angle (on degree) */ 
  $alpha = (($n - 1)/($measures)) * 360; 
  $alpha = $alpha + 15;
  
  
  /* center coords */ 
  $x = $x + 200; 
  $y = $y + 200; 

  /* now calculate coors */ 
  $res['x'] = $x + $distance * sin(deg2rad($alpha)); 
  $res['y'] = $y - $distance * cos(deg2rad($alpha)); 
  
  return $res; 
  
}


/* 
 * function used for generating height on a monitor map.
 * width is fixed to 1200 (3 hosts per lines) lines are used util 
 * they are hosts to display */ 
function get_render_height() {
  
  /* get the number of devices */ 
  $query = "select name from weathermap_graph group by name"; 
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  $devices = 0; 
  $prec = ""; 
  while ($rec = mysql_fetch_array($res)) {
    $graph = $rec['name']; 
    $thisone = explode(" - ", $graph); 
    $thisone = $thisone[0];  
    
    if ($prec != $thisone) {
      $devices++; 
      
    }
    $prec = $thisone; 
  }
    
  $lines = ceil($devices / 3); 
  $height = $lines * 400;
  
  /* let place for scale if needed */ 
  if ($devices % 3 == 0) $height = $height + 200; 
  return $height; 
 
}

/*
 * function used for getting the host description, 
 * giving on parameter a graph name... 
 * description is contained to the graph cache name, but db acces is 
 * required, for preventing from descriptions such as: 'text<space><minus><space>text'
 */ 
function get_host_desc($graph) {

  $query = "select description from host"; 
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  $desc = "";
  while ($rec = mysql_fetch_array($res)) {
    
    $d = $rec['description']; 
    if (strstr($graph, $d)) {

      /* the bigger wins */ 
      if (strlen($d) > strlen($desc))  $desc = $d; 
    }
  }
	 
  if ($desc == "") {
      print "<div debug>host not found from database?? Cacti data must have just changed...<br>Try clearing cache browser, then restart application.</div>";
      exit; 
  }
  return $desc; 

}


/* 
 * function for getting the speed from a device
 * call a Perl script which do a SNMP query. 
 */ 
function get_speed($host, $iface) {

  
  /* get snmp data from cacti base */
  $query = "select snmp_community, snmp_version from host where hostname = '$host'"; 
  $res = mysql_query($query); 
  if ($res == NULL) houston($query); 
  $rec = mysql_fetch_array($res); 
  $version = $rec['snmp_version']; 
  $community = $rec['snmp_community']; 
  
  /* call script */ 
  unset($soutput); 
  exec("./ifbrowse.pl $host $iface $community $version", $output);
  if (is_numeric($output[0])) {
    $speed = $output[0]; 
  }
  else {
    $speed = "-1"; 
    if ($output[0] == "version") {
      print "<div class=\"notice\">[NOTICE] Unable to get IF-SPEED from $host: SNMP protocol version error (check it from Cacti)<br></div>";
    }
    else if ($output[0] == "connection_if") {
      print "<div class=\"notice\">[NOTICE]  Unable to get IF-SPEED from $host: SNMP connection failed...<br></div>";
    }
    else if ($output[0] == "notfound") {
      print "<div class=\"notice\">[NOTICE] Unable to get IF-SPEED from $host:  Object not found on SNMP-MIB.<br></div>";
    }
    else if ($output[0] == "none") {
      print "<div class=\"notice\">[NOTICE] $host has no Interface?? SNMP is misconfigured?<br></div>";
    }
    else {
      print "<div class=\"notice\">[NOTICE] Unable to get IF-SPEED from $host:  no response on SNMP query...<br></div>";
    }
  }
  return $speed; 
}



/*
 * anable the map, by inserteing it to the weathermap database. 
 * everybody get permissions to see it. 
 */
function enable_map($confname) {


  $query = "select configfile, active from weathermap_maps where configfile = '$confname'";  
  $res = mysql_query($query); 
  if ($res == NULL) houston($query);
	
  $rec = mysql_fetch_array($res);
  
  /* not found into weathermap maps... add it */ 
  if ($rec['configfile'] == NULL) {
    
    /* sortorder needed... get the upper value, and increment */ 
    $order = 0; 
    $query = "select sortorder from weathermap_maps"; 
    $res = mysql_query($query);
    if ($res == NULL) houston($query);
    while ($rec = mysql_fetch_array($res)) {
      $val = $rec['sortorder'];
      if ($val > $order) $order = $val;  
    }
    $order++; 
    
    /* perform insertion */ 
    $query = "insert into weathermap_maps (sortorder, active, configfile, titlecache) values ($order, 'on', '$confname', '$title')";
    $res = mysql_query($query);
    if ($res == NULL) houston($query);
  
    /* get id */ 
    $query = "select id from weathermap_maps where configfile = '$confname'"; 
    $res = mysql_query($query); 
    if ($res == NULL) houston($query); 
    $rec = mysql_fetch_array($res); 
    $id = $rec['id']; 
    
    /* now update auth table -- (default give access to anyone) */
    $query = "insert into weathermap_auth (userid, mapid) values (0, $id)"; 
    $res = mysql_query($query); 
    if ($res == NULL) houston($query); 
    
  } 

  /* checks if active, and if not, active it. */ 
  else {

    $rec = mysql_fetch_array($res);
    if (strcmp($rec['active'], 'off') == 0) {
      $query = "update weathermap_maps (active) set ('on') where configfile = $confname";
      $res = mysql_query($query);
      if ($res == NULL) houston($query);
    }
  }


  /* close db, and send to mapweather editor */
  mysql_close();
  
}



/* an usefull debug debug function... */ 
function houston($query) {

  if ($_SESSION['debug']) {
    print "<div class=\"debug\">Houston, we've got a problem... Please try this:<br>"; 
    print "$query</div>"; 
  } 
  else 
    print "Mysql query failure... Aborting. "; 
  exit; 
}



?>
