-- Weathermanage 1.0
-- Mathieu Gilardet (matam@chokolate.org) 
-- Released under the GNU Public License

-- weathermap.sql 
-- sql script for creating table, used by weathermanage.php

-- create table weathermap_conf 
-- containing graphs configs files references 
CREATE TABLE weathermap_conf (
  id mediumint(8) unsigned NOT NULL auto_increment,
  mode tinyint(2) unsigned NOT NULL default 1,	
  name varchar(255) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  height mediumint(8) unsigned NOT NULL default 0,
  width mediumint(8) unsigned NOT NULL default 0,
  backgndimg varchar(255) NOT NULL default '',
  backgndcolor varchar(255) NOT NULL default '',
  timex mediumint(8) unsigned NOT NULL default 0,
  timey mediumint(8) unsigned NOT NULL default 0,
  timetext varchar(255) NOT NULL default '',
  timefont mediumint(8) unsigned NOT NULL default 0,
  captionx mediumint(8) unsigned NOT NULL default 0,
  captiony mediumint(8) unsigned NOT NULL default 0,
  captiontext varchar(255) NOT NULL default '',
  captioncolor varchar(6) NOT NULL default '',
  captionprec mediumint(8) unsigned NOT NULL default 0,
  captionfont mediumint(8) unsigned NOT NULL default 0,
  nodefont mediumint(8) unsigned NOT NULL default 0,
  nodecolor varchar(6) NOT NULL default '',
  linkfont mediumint(8) unsigned NOT NULL default 0,
  linkwidth mediumint(8) unsigned NOT NULL default 0,
  linkunit varchar(10) NOT NULL default '',
  secure tinyint(1) unsigned NOT NULL default 0, 
  PRIMARY KEY  (id)
) TYPE=MyISAM;


-- create table weathermap_nodes 
-- containing all nodes. 
-- a node belong to only one config, and has an interface. 
CREATE TABLE weathermap_node (
  id mediumint(8) unsigned NOT NULL auto_increment,
  hostname varchar(127) NOT NULL default '', 
  description varchar(127) NOT NULL default '', 
  ifname varchar(63) NOT NULL default '',
  ifdetails varchar(63) NOT NULL default 0,
  conf mediumint(8) unsigned NOT NULL default 0,
  PRIMARY KEY (id)
) TYPE=MyISAM;


-- create table weathermp_roads 
-- containing all roads
-- a road belong to only one config
CREATE TABLE weathermap_road (
  id mediumint(8) unsigned NOT NULL auto_increment,
  node1 varchar(127) NOT NULL default '',
  node2 varchar(127) NOT NULL default '',
  noderrd mediumint(8) unsigned NOT NULL default 0,
  available tinyint(1) unsigned NOT NULL default 0,	
  conf mediumint(8) unsigned NOT NULL default 0, 
  PRIMARY KEY (id)
) TYPE=MyISAM;

-- create table weathermap_graphs
-- containing all selected graphs
-- each graph belong to only one conf. 
CREATE TABLE weathermap_graph ( 
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  threshold varchar(15) NOT NULL default '', 
  conf mediumint(8) unsigned NOT NULL default 0, 
  PRIMARY KEY (id)
) TYPE=MyISAM;



